/* DBusAccelerator.c generated by valac 0.40.8, the Vala compiler
 * generated from DBusAccelerator.vala, do not modify */

/**/
/*  Copyright (C) 2015 Nicolas Bruguier, Corentin Noël*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "gala.h"
#include <meta/meta-plugin.h>
#include <meta/screen.h>
#include <meta/display.h>
#include <gobject/gvaluecollector.h>


#define GALA_TYPE_ACCELERATOR (gala_accelerator_get_type ())
typedef struct _GalaAccelerator GalaAccelerator;
#define _g_free0(var) (var = (g_free (var), NULL))

#define GALA_TYPE_DBUS_ACCELERATOR (gala_dbus_accelerator_get_type ())
#define GALA_DBUS_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAccelerator))
#define GALA_DBUS_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAcceleratorClass))
#define GALA_IS_DBUS_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DBUS_ACCELERATOR))
#define GALA_IS_DBUS_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_DBUS_ACCELERATOR))
#define GALA_DBUS_ACCELERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAcceleratorClass))

typedef struct _GalaDBusAccelerator GalaDBusAccelerator;
typedef struct _GalaDBusAcceleratorClass GalaDBusAcceleratorClass;
typedef struct _GalaDBusAcceleratorPrivate GalaDBusAcceleratorPrivate;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gala_dbus_accelerator_unref0(var) ((var == NULL) ? NULL : (var = (gala_dbus_accelerator_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GalaParamSpecDBusAccelerator GalaParamSpecDBusAccelerator;
enum  {
	GALA_DBUS_ACCELERATOR_ACCELERATOR_ACTIVATED_SIGNAL,
	GALA_DBUS_ACCELERATOR_NUM_SIGNALS
};
static guint gala_dbus_accelerator_signals[GALA_DBUS_ACCELERATOR_NUM_SIGNALS] = {0};

struct _GalaAccelerator {
	gchar* name;
	guint flags;
};

struct _GalaDBusAccelerator {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GalaDBusAcceleratorPrivate * priv;
};

struct _GalaDBusAcceleratorClass {
	GTypeClass parent_class;
	void (*finalize) (GalaDBusAccelerator *self);
};

struct _GalaDBusAcceleratorPrivate {
	GHashTable* grabbed_accelerators;
};

struct _GalaParamSpecDBusAccelerator {
	GParamSpec parent_instance;
};


static gpointer gala_dbus_accelerator_parent_class = NULL;
static GalaDBusAccelerator* gala_dbus_accelerator_instance;
static GalaDBusAccelerator* gala_dbus_accelerator_instance = NULL;
static GalaWindowManager* gala_dbus_accelerator_wm;
static GalaWindowManager* gala_dbus_accelerator_wm = NULL;

GType gala_accelerator_get_type (void) G_GNUC_CONST;
GalaAccelerator* gala_accelerator_dup (const GalaAccelerator* self);
void gala_accelerator_free (GalaAccelerator* self);
void gala_accelerator_copy (const GalaAccelerator* self,
                            GalaAccelerator* dest);
void gala_accelerator_destroy (GalaAccelerator* self);
gpointer gala_dbus_accelerator_ref (gpointer instance);
void gala_dbus_accelerator_unref (gpointer instance);
GParamSpec* gala_param_spec_dbus_accelerator (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags);
void gala_value_set_dbus_accelerator (GValue* value,
                                      gpointer v_object);
void gala_value_take_dbus_accelerator (GValue* value,
                                       gpointer v_object);
gpointer gala_value_get_dbus_accelerator (const GValue* value);
GType gala_dbus_accelerator_get_type (void) G_GNUC_CONST;
guint gala_dbus_accelerator_register_object (void* object,
                                             GDBusConnection* connection,
                                             const gchar* path,
                                             GError** error);
#define GALA_DBUS_ACCELERATOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAcceleratorPrivate))
void gala_dbus_accelerator_init (GalaWindowManager* _wm);
static void __lambda180_ (GDBusConnection* connection);
static GalaDBusAccelerator* gala_dbus_accelerator_new (void);
static GalaDBusAccelerator* gala_dbus_accelerator_construct (GType object_type);
static void ___lambda180__gbus_acquired_callback (GDBusConnection* connection,
                                           const gchar* name,
                                           gpointer self);
static void __lambda181_ (void);
static void ___lambda181__gbus_name_acquired_callback (GDBusConnection* connection,
                                                const gchar* name,
                                                gpointer self);
static void __lambda182_ (void);
static void ___lambda182__gbus_name_lost_callback (GDBusConnection* connection,
                                            const gchar* name,
                                            gpointer self);
static void _g_free0_ (gpointer var);
static void gala_dbus_accelerator_on_accelerator_activated (GalaDBusAccelerator* self,
                                                     guint action,
                                                     guint device_id,
                                                     guint timestamp);
static void _gala_dbus_accelerator_on_accelerator_activated_meta_display_accelerator_activated (MetaDisplay* _sender,
                                                                                         guint object,
                                                                                         guint p0,
                                                                                         guint p1,
                                                                                         gpointer self);
static gboolean _uint_equal (const guint * s1,
                      const guint * s2);
guint gala_dbus_accelerator_grab_accelerator (GalaDBusAccelerator* self,
                                              const gchar* accelerator,
                                              guint flags);
static guint* _uint_dup (guint* self);
guint* gala_dbus_accelerator_grab_accelerators (GalaDBusAccelerator* self,
                                                GalaAccelerator* accelerators,
                                                int accelerators_length1,
                                                int* result_length1);
static void _vala_array_add1 (guint* * array,
                       int* length,
                       int* size,
                       guint value);
gboolean gala_dbus_accelerator_ungrab_accelerator (GalaDBusAccelerator* self,
                                                   guint action);
static void g_cclosure_user_marshal_VOID__UINT_UINT_UINT (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void gala_dbus_accelerator_finalize (GalaDBusAccelerator * obj);
static void _dbus_gala_dbus_accelerator_grab_accelerator (GalaDBusAccelerator* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation);
static void _vala_GalaAccelerator_array_free (GalaAccelerator * array,
                                       gint array_length);
static void _dbus_gala_dbus_accelerator_grab_accelerators (GalaDBusAccelerator* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation);
static void _dbus_gala_dbus_accelerator_ungrab_accelerator (GalaDBusAccelerator* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation);
static void gala_dbus_accelerator_dbus_interface_method_call (GDBusConnection* connection,
                                                       const gchar* sender,
                                                       const gchar* object_path,
                                                       const gchar* interface_name,
                                                       const gchar* method_name,
                                                       GVariant* parameters,
                                                       GDBusMethodInvocation* invocation,
                                                       gpointer user_data);
static GVariant* gala_dbus_accelerator_dbus_interface_get_property (GDBusConnection* connection,
                                                             const gchar* sender,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* property_name,
                                                             GError** error,
                                                             gpointer user_data);
static gboolean gala_dbus_accelerator_dbus_interface_set_property (GDBusConnection* connection,
                                                            const gchar* sender,
                                                            const gchar* object_path,
                                                            const gchar* interface_name,
                                                            const gchar* property_name,
                                                            GVariant* value,
                                                            GError** error,
                                                            gpointer user_data);
static void _dbus_gala_dbus_accelerator_accelerator_activated (GObject* _sender,
                                                        guint action,
                                                        guint device_id,
                                                        guint timestamp,
                                                        gpointer* _data);
static void _gala_dbus_accelerator_unregister_object (gpointer user_data);

static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_accelerator = {-1, "accelerator", "s"};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_flags = {-1, "flags", "u"};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_result = {-1, "result", "u"};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_in[] = {&_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_accelerator, &_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_flags, NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_out[] = {&_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_result, NULL};
static const GDBusMethodInfo _gala_dbus_accelerator_dbus_method_info_grab_accelerator = {-1, "GrabAccelerator", (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_in), (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_out)};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerators_accelerators = {-1, "accelerators", "a(su)"};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerators_result = {-1, "result", "au"};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_grab_accelerators_in[] = {&_gala_dbus_accelerator_dbus_arg_info_grab_accelerators_accelerators, NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_grab_accelerators_out[] = {&_gala_dbus_accelerator_dbus_arg_info_grab_accelerators_result, NULL};
static const GDBusMethodInfo _gala_dbus_accelerator_dbus_method_info_grab_accelerators = {-1, "GrabAccelerators", (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_grab_accelerators_in), (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_grab_accelerators_out)};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_action = {-1, "action", "u"};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_result = {-1, "result", "b"};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_in[] = {&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_action, NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_out[] = {&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_result, NULL};
static const GDBusMethodInfo _gala_dbus_accelerator_dbus_method_info_ungrab_accelerator = {-1, "UngrabAccelerator", (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_in), (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_out)};
static const GDBusMethodInfo * const _gala_dbus_accelerator_dbus_method_info[] = {&_gala_dbus_accelerator_dbus_method_info_grab_accelerator, &_gala_dbus_accelerator_dbus_method_info_grab_accelerators, &_gala_dbus_accelerator_dbus_method_info_ungrab_accelerator, NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_accelerator_activated_action = {-1, "action", "u"};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_accelerator_activated_device_id = {-1, "device_id", "u"};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_accelerator_activated_timestamp = {-1, "timestamp", "u"};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_accelerator_activated[] = {&_gala_dbus_accelerator_dbus_arg_info_accelerator_activated_action, &_gala_dbus_accelerator_dbus_arg_info_accelerator_activated_device_id, &_gala_dbus_accelerator_dbus_arg_info_accelerator_activated_timestamp, NULL};
static const GDBusSignalInfo _gala_dbus_accelerator_dbus_signal_info_accelerator_activated = {-1, "AcceleratorActivated", (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_accelerator_activated)};
static const GDBusSignalInfo * const _gala_dbus_accelerator_dbus_signal_info[] = {&_gala_dbus_accelerator_dbus_signal_info_accelerator_activated, NULL};
static const GDBusPropertyInfo * const _gala_dbus_accelerator_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _gala_dbus_accelerator_dbus_interface_info = {-1, "org.gnome.Shell", (GDBusMethodInfo **) (&_gala_dbus_accelerator_dbus_method_info), (GDBusSignalInfo **) (&_gala_dbus_accelerator_dbus_signal_info), (GDBusPropertyInfo **) (&_gala_dbus_accelerator_dbus_property_info)};
static const GDBusInterfaceVTable _gala_dbus_accelerator_dbus_interface_vtable = {gala_dbus_accelerator_dbus_interface_method_call, gala_dbus_accelerator_dbus_interface_get_property, gala_dbus_accelerator_dbus_interface_set_property};

void
gala_accelerator_copy (const GalaAccelerator* self,
                       GalaAccelerator* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	guint _tmp2_;
#line 20 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp0_ = (*self).name;
#line 20 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 20 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_g_free0 ((*dest).name);
#line 20 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	(*dest).name = _tmp1_;
#line 20 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp2_ = (*self).flags;
#line 20 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	(*dest).flags = _tmp2_;
#line 250 "DBusAccelerator.c"
}


void
gala_accelerator_destroy (GalaAccelerator* self)
{
#line 22 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_g_free0 ((*self).name);
#line 259 "DBusAccelerator.c"
}


GalaAccelerator*
gala_accelerator_dup (const GalaAccelerator* self)
{
	GalaAccelerator* dup;
#line 20 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	dup = g_new0 (GalaAccelerator, 1);
#line 20 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	gala_accelerator_copy (self, dup);
#line 20 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return dup;
#line 273 "DBusAccelerator.c"
}


void
gala_accelerator_free (GalaAccelerator* self)
{
#line 20 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	gala_accelerator_destroy (self);
#line 20 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_free (self);
#line 284 "DBusAccelerator.c"
}


GType
gala_accelerator_get_type (void)
{
	static volatile gsize gala_accelerator_type_id__volatile = 0;
	if (g_once_init_enter (&gala_accelerator_type_id__volatile)) {
		GType gala_accelerator_type_id;
		gala_accelerator_type_id = g_boxed_type_register_static ("GalaAccelerator", (GBoxedCopyFunc) gala_accelerator_dup, (GBoxedFreeFunc) gala_accelerator_free);
		g_once_init_leave (&gala_accelerator_type_id__volatile, gala_accelerator_type_id);
	}
	return gala_accelerator_type_id__volatile;
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 35 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return self ? g_object_ref (self) : NULL;
#line 306 "DBusAccelerator.c"
}


static void
__lambda180_ (GDBusConnection* connection)
{
	GalaDBusAccelerator* _tmp0_;
	GError * _inner_error_ = NULL;
#line 38 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_return_if_fail (connection != NULL);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp0_ = gala_dbus_accelerator_instance;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (_tmp0_ == NULL) {
#line 321 "DBusAccelerator.c"
		GalaDBusAccelerator* _tmp1_;
#line 40 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		_tmp1_ = gala_dbus_accelerator_new ();
#line 40 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		_gala_dbus_accelerator_unref0 (gala_dbus_accelerator_instance);
#line 40 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		gala_dbus_accelerator_instance = _tmp1_;
#line 329 "DBusAccelerator.c"
	}
	{
		GalaDBusAccelerator* _tmp2_;
#line 43 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		_tmp2_ = gala_dbus_accelerator_instance;
#line 43 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		gala_dbus_accelerator_register_object (_tmp2_, connection, "/org/gnome/Shell", &_inner_error_);
#line 43 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 339 "DBusAccelerator.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 42 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		e = _inner_error_;
#line 42 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		_inner_error_ = NULL;
#line 44 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		_tmp3_ = e;
#line 44 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		_tmp4_ = _tmp3_->message;
#line 44 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		g_warning ("DBusAccelerator.vala:44: %s", _tmp4_);
#line 42 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		_g_error_free0 (e);
#line 361 "DBusAccelerator.c"
	}
	__finally1:
#line 42 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 42 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 42 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		g_clear_error (&_inner_error_);
#line 42 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		return;
#line 372 "DBusAccelerator.c"
	}
}


static void
___lambda180__gbus_acquired_callback (GDBusConnection* connection,
                                      const gchar* name,
                                      gpointer self)
{
#line 37 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	__lambda180_ (connection);
#line 384 "DBusAccelerator.c"
}


static void
__lambda181_ (void)
{
}


static void
___lambda181__gbus_name_acquired_callback (GDBusConnection* connection,
                                           const gchar* name,
                                           gpointer self)
{
#line 37 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	__lambda181_ ();
#line 401 "DBusAccelerator.c"
}


static void
__lambda182_ (void)
{
#line 47 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_critical ("DBusAccelerator.vala:47: Could not acquire name");
#line 410 "DBusAccelerator.c"
}


static void
___lambda182__gbus_name_lost_callback (GDBusConnection* connection,
                                       const gchar* name,
                                       gpointer self)
{
#line 37 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	__lambda182_ ();
#line 421 "DBusAccelerator.c"
}


void
gala_dbus_accelerator_init (GalaWindowManager* _wm)
{
	GalaWindowManager* _tmp0_;
#line 33 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_return_if_fail (_wm != NULL);
#line 35 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp0_ = _g_object_ref0 (_wm);
#line 35 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_g_object_unref0 (gala_dbus_accelerator_wm);
#line 35 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	gala_dbus_accelerator_wm = _tmp0_;
#line 37 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_bus_own_name_with_closures (G_BUS_TYPE_SESSION, "org.gnome.Shell", G_BUS_NAME_OWNER_FLAGS_NONE, (GClosure*) ((___lambda180__gbus_acquired_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda180__gbus_acquired_callback, NULL, (GClosureNotify) NULL)), (GClosure*) ((___lambda181__gbus_name_acquired_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda181__gbus_name_acquired_callback, NULL, (GClosureNotify) NULL)), (GClosure*) ((___lambda182__gbus_name_lost_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda182__gbus_name_lost_callback, NULL, (GClosureNotify) NULL)));
#line 439 "DBusAccelerator.c"
}


static void
_g_free0_ (gpointer var)
{
#line 60 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	var = (g_free (var), NULL);
#line 448 "DBusAccelerator.c"
}


static void
_gala_dbus_accelerator_on_accelerator_activated_meta_display_accelerator_activated (MetaDisplay* _sender,
                                                                                    guint object,
                                                                                    guint p0,
                                                                                    guint p1,
                                                                                    gpointer self)
{
#line 62 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	gala_dbus_accelerator_on_accelerator_activated ((GalaDBusAccelerator*) self, object, p0, p1);
#line 461 "DBusAccelerator.c"
}


static GalaDBusAccelerator*
gala_dbus_accelerator_construct (GType object_type)
{
	GalaDBusAccelerator* self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GalaWindowManager* _tmp3_;
	MetaScreen* _tmp4_;
	MetaDisplay* _tmp5_;
#line 58 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	self = (GalaDBusAccelerator*) g_type_create_instance (object_type);
#line 60 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp0_ = g_str_hash;
#line 60 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp1_ = g_str_equal;
#line 60 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, NULL);
#line 60 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_g_hash_table_unref0 (self->priv->grabbed_accelerators);
#line 60 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	self->priv->grabbed_accelerators = _tmp2_;
#line 62 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp3_ = gala_dbus_accelerator_wm;
#line 62 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp4_ = meta_plugin_get_screen ((MetaPlugin*) _tmp3_);
#line 62 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp5_ = meta_screen_get_display (_tmp4_);
#line 62 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_signal_connect (_tmp5_, "accelerator-activated", (GCallback) _gala_dbus_accelerator_on_accelerator_activated_meta_display_accelerator_activated, self);
#line 58 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return self;
#line 497 "DBusAccelerator.c"
}


static GalaDBusAccelerator*
gala_dbus_accelerator_new (void)
{
#line 58 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return gala_dbus_accelerator_construct (GALA_TYPE_DBUS_ACCELERATOR);
#line 506 "DBusAccelerator.c"
}


static gboolean
_uint_equal (const guint * s1,
             const guint * s2)
{
#line 68 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (s1 == s2) {
#line 68 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		return TRUE;
#line 518 "DBusAccelerator.c"
	}
#line 68 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (s1 == NULL) {
#line 68 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		return FALSE;
#line 524 "DBusAccelerator.c"
	}
#line 68 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (s2 == NULL) {
#line 68 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		return FALSE;
#line 530 "DBusAccelerator.c"
	}
#line 68 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return (*s1) == (*s2);
#line 534 "DBusAccelerator.c"
}


static void
gala_dbus_accelerator_on_accelerator_activated (GalaDBusAccelerator* self,
                                                guint action,
                                                guint device_id,
                                                guint timestamp)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
#line 65 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_return_if_fail (self != NULL);
#line 67 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp0_ = self->priv->grabbed_accelerators;
#line 67 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
#line 552 "DBusAccelerator.c"
	{
		GList* accelerator_collection = NULL;
		GList* accelerator_it = NULL;
#line 67 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		accelerator_collection = _tmp1_;
#line 67 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		for (accelerator_it = accelerator_collection; accelerator_it != NULL; accelerator_it = accelerator_it->next) {
#line 560 "DBusAccelerator.c"
			gchar* _tmp2_;
			gchar* accelerator = NULL;
#line 67 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
			_tmp2_ = g_strdup ((const gchar*) accelerator_it->data);
#line 67 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
			accelerator = _tmp2_;
#line 567 "DBusAccelerator.c"
			{
				GHashTable* _tmp3_;
				const gchar* _tmp4_;
				gconstpointer _tmp5_;
#line 68 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				_tmp3_ = self->priv->grabbed_accelerators;
#line 68 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				_tmp4_ = accelerator;
#line 68 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				_tmp5_ = g_hash_table_lookup (_tmp3_, _tmp4_);
#line 68 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				if (_uint_equal ((guint*) _tmp5_, &action) == TRUE) {
#line 76 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
					g_signal_emit (self, gala_dbus_accelerator_signals[GALA_DBUS_ACCELERATOR_ACCELERATOR_ACTIVATED_SIGNAL], 0, action, device_id, timestamp);
#line 582 "DBusAccelerator.c"
				}
#line 67 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				_g_free0 (accelerator);
#line 586 "DBusAccelerator.c"
			}
		}
#line 67 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		(accelerator_collection == NULL) ? NULL : (accelerator_collection = (g_list_free (accelerator_collection), NULL));
#line 591 "DBusAccelerator.c"
	}
}


static guint*
_uint_dup (guint* self)
{
	guint* dup;
#line 84 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	dup = g_new0 (guint, 1);
#line 84 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	memcpy (dup, self, sizeof (guint));
#line 84 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return dup;
#line 606 "DBusAccelerator.c"
}


static gpointer
__uint_dup0 (gpointer self)
{
#line 84 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return self ? _uint_dup (self) : NULL;
#line 615 "DBusAccelerator.c"
}


guint
gala_dbus_accelerator_grab_accelerator (GalaDBusAccelerator* self,
                                        const gchar* accelerator,
                                        guint flags)
{
	guint result = 0U;
	guint* action = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	guint* _tmp2_;
	guint* _tmp3_;
	guint* _tmp14_;
	guint _tmp15_;
#line 82 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 82 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_return_val_if_fail (accelerator != NULL, 0U);
#line 84 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp0_ = self->priv->grabbed_accelerators;
#line 84 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, accelerator);
#line 84 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp2_ = __uint_dup0 ((guint*) _tmp1_);
#line 84 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	action = _tmp2_;
#line 86 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp3_ = action;
#line 86 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (_tmp3_ == NULL) {
#line 648 "DBusAccelerator.c"
		GalaWindowManager* _tmp4_;
		MetaScreen* _tmp5_;
		MetaDisplay* _tmp6_;
		guint _tmp7_;
		guint* _tmp8_;
		guint* _tmp9_;
#line 87 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		_tmp4_ = gala_dbus_accelerator_wm;
#line 87 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		_tmp5_ = meta_plugin_get_screen ((MetaPlugin*) _tmp4_);
#line 87 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		_tmp6_ = meta_screen_get_display (_tmp5_);
#line 87 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		_tmp7_ = meta_display_grab_accelerator (_tmp6_, accelerator);
#line 87 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		_tmp8_ = __uint_dup0 (&_tmp7_);
#line 87 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		_g_free0 (action);
#line 87 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		action = _tmp8_;
#line 88 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		_tmp9_ = action;
#line 88 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		if ((*_tmp9_) > ((guint) 0)) {
#line 673 "DBusAccelerator.c"
			GHashTable* _tmp10_;
			gchar* _tmp11_;
			guint* _tmp12_;
			guint* _tmp13_;
#line 89 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
			_tmp10_ = self->priv->grabbed_accelerators;
#line 89 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
			_tmp11_ = g_strdup (accelerator);
#line 89 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
			_tmp12_ = action;
#line 89 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
			_tmp13_ = __uint_dup0 (_tmp12_);
#line 89 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
			g_hash_table_insert (_tmp10_, _tmp11_, _tmp13_);
#line 688 "DBusAccelerator.c"
		}
	}
#line 93 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp14_ = action;
#line 93 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp15_ = *_tmp14_;
#line 93 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_g_free0 (_tmp14_);
#line 93 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	result = _tmp15_;
#line 93 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return result;
#line 701 "DBusAccelerator.c"
}


static void
_vala_array_add1 (guint* * array,
                  int* length,
                  int* size,
                  guint value)
{
#line 101 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if ((*length) == (*size)) {
#line 101 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 101 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		*array = g_renew (guint, *array, *size);
#line 717 "DBusAccelerator.c"
	}
#line 101 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	(*array)[(*length)++] = value;
#line 721 "DBusAccelerator.c"
}


guint*
gala_dbus_accelerator_grab_accelerators (GalaDBusAccelerator* self,
                                         GalaAccelerator* accelerators,
                                         int accelerators_length1,
                                         int* result_length1)
{
	guint* result = NULL;
	guint* actions = NULL;
	guint* _tmp0_;
	gint actions_length1;
	gint _actions_size_;
	guint* _tmp6_;
	gint _tmp6__length1;
#line 96 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 98 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp0_ = g_new0 (guint, 0);
#line 98 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	actions = _tmp0_;
#line 98 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	actions_length1 = 0;
#line 98 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_actions_size_ = actions_length1;
#line 748 "DBusAccelerator.c"
	{
		GalaAccelerator* accelerator_collection = NULL;
		gint accelerator_collection_length1 = 0;
		gint _accelerator_collection_size_ = 0;
		gint accelerator_it = 0;
#line 100 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		accelerator_collection = accelerators;
#line 100 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		accelerator_collection_length1 = accelerators_length1;
#line 100 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		for (accelerator_it = 0; accelerator_it < accelerators_length1; accelerator_it = accelerator_it + 1) {
#line 760 "DBusAccelerator.c"
			GalaAccelerator* accelerator = NULL;
#line 100 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
			accelerator = &accelerator_collection[accelerator_it];
#line 764 "DBusAccelerator.c"
			{
				guint* _tmp1_;
				gint _tmp1__length1;
				GalaAccelerator* _tmp2_;
				const gchar* _tmp3_;
				GalaAccelerator* _tmp4_;
				guint _tmp5_;
#line 101 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				_tmp1_ = actions;
#line 101 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				_tmp1__length1 = actions_length1;
#line 101 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				_tmp2_ = accelerator;
#line 101 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				_tmp3_ = (*_tmp2_).name;
#line 101 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				_tmp4_ = accelerator;
#line 101 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				_tmp5_ = (*_tmp4_).flags;
#line 101 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				_vala_array_add1 (&actions, &actions_length1, &_actions_size_, gala_dbus_accelerator_grab_accelerator (self, _tmp3_, _tmp5_));
#line 786 "DBusAccelerator.c"
			}
		}
	}
#line 104 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp6_ = actions;
#line 104 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp6__length1 = actions_length1;
#line 104 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (result_length1) {
#line 104 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		*result_length1 = _tmp6__length1;
#line 798 "DBusAccelerator.c"
	}
#line 104 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	result = _tmp6_;
#line 104 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return result;
#line 804 "DBusAccelerator.c"
}


gboolean
gala_dbus_accelerator_ungrab_accelerator (GalaDBusAccelerator* self,
                                          guint action)
{
	gboolean result = FALSE;
	gboolean ret = FALSE;
	GHashTable* _tmp0_;
	GList* _tmp1_;
#line 107 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 109 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	ret = FALSE;
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp0_ = self->priv->grabbed_accelerators;
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
#line 824 "DBusAccelerator.c"
	{
		GList* accelerator_collection = NULL;
		GList* accelerator_it = NULL;
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		accelerator_collection = _tmp1_;
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		for (accelerator_it = accelerator_collection; accelerator_it != NULL; accelerator_it = accelerator_it->next) {
#line 832 "DBusAccelerator.c"
			const gchar* accelerator = NULL;
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
			accelerator = (const gchar*) accelerator_it->data;
#line 836 "DBusAccelerator.c"
			{
				GHashTable* _tmp2_;
				const gchar* _tmp3_;
				gconstpointer _tmp4_;
#line 112 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				_tmp2_ = self->priv->grabbed_accelerators;
#line 112 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				_tmp3_ = accelerator;
#line 112 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				_tmp4_ = g_hash_table_lookup (_tmp2_, _tmp3_);
#line 112 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
				if (_uint_equal ((guint*) _tmp4_, &action) == TRUE) {
#line 849 "DBusAccelerator.c"
					GalaWindowManager* _tmp5_;
					MetaScreen* _tmp6_;
					MetaDisplay* _tmp7_;
					GHashTable* _tmp8_;
					const gchar* _tmp9_;
#line 113 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
					_tmp5_ = gala_dbus_accelerator_wm;
#line 113 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
					_tmp6_ = meta_plugin_get_screen ((MetaPlugin*) _tmp5_);
#line 113 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
					_tmp7_ = meta_screen_get_display (_tmp6_);
#line 113 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
					ret = meta_display_ungrab_accelerator (_tmp7_, action);
#line 114 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
					_tmp8_ = self->priv->grabbed_accelerators;
#line 114 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
					_tmp9_ = accelerator;
#line 114 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
					g_hash_table_remove (_tmp8_, _tmp9_);
#line 115 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
					break;
#line 871 "DBusAccelerator.c"
				}
			}
		}
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		(accelerator_collection == NULL) ? NULL : (accelerator_collection = (g_list_free (accelerator_collection), NULL));
#line 877 "DBusAccelerator.c"
	}
#line 119 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	result = ret;
#line 119 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return result;
#line 883 "DBusAccelerator.c"
}


static void
g_cclosure_user_marshal_VOID__UINT_UINT_UINT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_UINT_UINT) (gpointer data1, guint arg_1, guint arg_2, guint arg_3, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_return_if_fail (n_param_values == 4);
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		data1 = closure->data;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		data2 = param_values->data[0].v_pointer;
#line 909 "DBusAccelerator.c"
	} else {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		data1 = param_values->data[0].v_pointer;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		data2 = closure->data;
#line 915 "DBusAccelerator.c"
	}
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	callback = (GMarshalFunc_VOID__UINT_UINT_UINT) (marshal_data ? marshal_data : cc->callback);
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), g_value_get_uint (param_values + 3), data2);
#line 921 "DBusAccelerator.c"
}


static void
gala_value_dbus_accelerator_init (GValue* value)
{
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	value->data[0].v_pointer = NULL;
#line 930 "DBusAccelerator.c"
}


static void
gala_value_dbus_accelerator_free_value (GValue* value)
{
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (value->data[0].v_pointer) {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		gala_dbus_accelerator_unref (value->data[0].v_pointer);
#line 941 "DBusAccelerator.c"
	}
}


static void
gala_value_dbus_accelerator_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (src_value->data[0].v_pointer) {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		dest_value->data[0].v_pointer = gala_dbus_accelerator_ref (src_value->data[0].v_pointer);
#line 954 "DBusAccelerator.c"
	} else {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		dest_value->data[0].v_pointer = NULL;
#line 958 "DBusAccelerator.c"
	}
}


static gpointer
gala_value_dbus_accelerator_peek_pointer (const GValue* value)
{
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return value->data[0].v_pointer;
#line 968 "DBusAccelerator.c"
}


static gchar*
gala_value_dbus_accelerator_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (collect_values[0].v_pointer) {
#line 980 "DBusAccelerator.c"
		GalaDBusAccelerator * object;
		object = collect_values[0].v_pointer;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		if (object->parent_instance.g_class == NULL) {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 987 "DBusAccelerator.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 991 "DBusAccelerator.c"
		}
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		value->data[0].v_pointer = gala_dbus_accelerator_ref (object);
#line 995 "DBusAccelerator.c"
	} else {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		value->data[0].v_pointer = NULL;
#line 999 "DBusAccelerator.c"
	}
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return NULL;
#line 1003 "DBusAccelerator.c"
}


static gchar*
gala_value_dbus_accelerator_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	GalaDBusAccelerator ** object_p;
	object_p = collect_values[0].v_pointer;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (!object_p) {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1019 "DBusAccelerator.c"
	}
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (!value->data[0].v_pointer) {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		*object_p = NULL;
#line 1025 "DBusAccelerator.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		*object_p = value->data[0].v_pointer;
#line 1029 "DBusAccelerator.c"
	} else {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		*object_p = gala_dbus_accelerator_ref (value->data[0].v_pointer);
#line 1033 "DBusAccelerator.c"
	}
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return NULL;
#line 1037 "DBusAccelerator.c"
}


GParamSpec*
gala_param_spec_dbus_accelerator (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	GalaParamSpecDBusAccelerator* spec;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GALA_TYPE_DBUS_ACCELERATOR), NULL);
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return G_PARAM_SPEC (spec);
#line 1057 "DBusAccelerator.c"
}


gpointer
gala_value_get_dbus_accelerator (const GValue* value)
{
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_DBUS_ACCELERATOR), NULL);
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return value->data[0].v_pointer;
#line 1068 "DBusAccelerator.c"
}


void
gala_value_set_dbus_accelerator (GValue* value,
                                 gpointer v_object)
{
	GalaDBusAccelerator * old;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_DBUS_ACCELERATOR));
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	old = value->data[0].v_pointer;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (v_object) {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_TYPE_DBUS_ACCELERATOR));
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		value->data[0].v_pointer = v_object;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		gala_dbus_accelerator_ref (value->data[0].v_pointer);
#line 1091 "DBusAccelerator.c"
	} else {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		value->data[0].v_pointer = NULL;
#line 1095 "DBusAccelerator.c"
	}
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (old) {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		gala_dbus_accelerator_unref (old);
#line 1101 "DBusAccelerator.c"
	}
}


void
gala_value_take_dbus_accelerator (GValue* value,
                                  gpointer v_object)
{
	GalaDBusAccelerator * old;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_DBUS_ACCELERATOR));
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	old = value->data[0].v_pointer;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (v_object) {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_TYPE_DBUS_ACCELERATOR));
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		value->data[0].v_pointer = v_object;
#line 1123 "DBusAccelerator.c"
	} else {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		value->data[0].v_pointer = NULL;
#line 1127 "DBusAccelerator.c"
	}
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (old) {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		gala_dbus_accelerator_unref (old);
#line 1133 "DBusAccelerator.c"
	}
}


static void
gala_dbus_accelerator_class_init (GalaDBusAcceleratorClass * klass)
{
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	gala_dbus_accelerator_parent_class = g_type_class_peek_parent (klass);
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	((GalaDBusAcceleratorClass *) klass)->finalize = gala_dbus_accelerator_finalize;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_type_class_add_private (klass, sizeof (GalaDBusAcceleratorPrivate));
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	gala_dbus_accelerator_signals[GALA_DBUS_ACCELERATOR_ACCELERATOR_ACTIVATED_SIGNAL] = g_signal_new ("accelerator-activated", GALA_TYPE_DBUS_ACCELERATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT_UINT, G_TYPE_NONE, 3, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT);
#line 1149 "DBusAccelerator.c"
}


static void
gala_dbus_accelerator_instance_init (GalaDBusAccelerator * self)
{
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	self->priv = GALA_DBUS_ACCELERATOR_GET_PRIVATE (self);
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	self->ref_count = 1;
#line 1160 "DBusAccelerator.c"
}


static void
gala_dbus_accelerator_finalize (GalaDBusAccelerator * obj)
{
	GalaDBusAccelerator * self;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAccelerator);
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_signal_handlers_destroy (self);
#line 56 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	_g_hash_table_unref0 (self->priv->grabbed_accelerators);
#line 1174 "DBusAccelerator.c"
}


GType
gala_dbus_accelerator_get_type (void)
{
	static volatile gsize gala_dbus_accelerator_type_id__volatile = 0;
	if (g_once_init_enter (&gala_dbus_accelerator_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gala_value_dbus_accelerator_init, gala_value_dbus_accelerator_free_value, gala_value_dbus_accelerator_copy_value, gala_value_dbus_accelerator_peek_pointer, "p", gala_value_dbus_accelerator_collect_value, "p", gala_value_dbus_accelerator_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GalaDBusAcceleratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_dbus_accelerator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaDBusAccelerator), 0, (GInstanceInitFunc) gala_dbus_accelerator_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gala_dbus_accelerator_type_id;
		gala_dbus_accelerator_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GalaDBusAccelerator", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_type_set_qdata (gala_dbus_accelerator_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) gala_dbus_accelerator_register_object);
		g_once_init_leave (&gala_dbus_accelerator_type_id__volatile, gala_dbus_accelerator_type_id);
	}
	return gala_dbus_accelerator_type_id__volatile;
}


gpointer
gala_dbus_accelerator_ref (gpointer instance)
{
	GalaDBusAccelerator * self;
	self = instance;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	g_atomic_int_inc (&self->ref_count);
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	return instance;
#line 1204 "DBusAccelerator.c"
}


void
gala_dbus_accelerator_unref (gpointer instance)
{
	GalaDBusAccelerator * self;
	self = instance;
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		GALA_DBUS_ACCELERATOR_GET_CLASS (self)->finalize (self);
#line 27 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DBusAccelerator.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1219 "DBusAccelerator.c"
	}
}


static void
_dbus_gala_dbus_accelerator_grab_accelerator (GalaDBusAccelerator* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* accelerator = NULL;
	GVariant* _tmp12_;
	guint flags = 0U;
	GVariant* _tmp13_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp12_ = g_variant_iter_next_value (&_arguments_iter);
	accelerator = g_variant_dup_string (_tmp12_, NULL);
	g_variant_unref (_tmp12_);
	_tmp13_ = g_variant_iter_next_value (&_arguments_iter);
	flags = g_variant_get_uint32 (_tmp13_);
	g_variant_unref (_tmp13_);
	result = gala_dbus_accelerator_grab_accelerator (self, accelerator, flags);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (accelerator);
}


static void
_vala_GalaAccelerator_array_free (GalaAccelerator * array,
                                  gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			gala_accelerator_destroy (&array[i]);
		}
	}
	g_free (array);
}


static void
_dbus_gala_dbus_accelerator_grab_accelerators (GalaDBusAccelerator* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GalaAccelerator* accelerators = NULL;
	int accelerators_length1 = 0;
	GVariant* _tmp14_;
	GalaAccelerator* _tmp15_;
	int _tmp15__length;
	int _tmp15__size;
	int _tmp15__length1;
	GVariantIter _tmp16_;
	GVariant* _tmp17_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint* result;
	int result_length1 = 0;
	guint* _tmp22_;
	GVariantBuilder _tmp23_;
	int _tmp24_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp14_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp15_ = g_new (GalaAccelerator, 5);
	_tmp15__length = 0;
	_tmp15__size = 4;
	_tmp15__length1 = 0;
	g_variant_iter_init (&_tmp16_, _tmp14_);
	for (; (_tmp17_ = g_variant_iter_next_value (&_tmp16_)) != NULL; _tmp15__length1++) {
		GalaAccelerator _tmp18_;
		GVariantIter _tmp19_;
		GVariant* _tmp20_;
		GVariant* _tmp21_;
		if (_tmp15__size == _tmp15__length) {
			_tmp15__size = 2 * _tmp15__size;
			_tmp15_ = g_renew (GalaAccelerator, _tmp15_, _tmp15__size + 1);
		}
		g_variant_iter_init (&_tmp19_, _tmp17_);
		_tmp20_ = g_variant_iter_next_value (&_tmp19_);
		_tmp18_.name = g_variant_dup_string (_tmp20_, NULL);
		g_variant_unref (_tmp20_);
		_tmp21_ = g_variant_iter_next_value (&_tmp19_);
		_tmp18_.flags = g_variant_get_uint32 (_tmp21_);
		g_variant_unref (_tmp21_);
		_tmp15_[_tmp15__length++] = _tmp18_;
		g_variant_unref (_tmp17_);
	}
	accelerators_length1 = _tmp15__length1;
	accelerators = _tmp15_;
	g_variant_unref (_tmp14_);
	result = gala_dbus_accelerator_grab_accelerators (self, accelerators, accelerators_length1, &result_length1);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp22_ = result;
	g_variant_builder_init (&_tmp23_, G_VARIANT_TYPE ("au"));
	for (_tmp24_ = 0; _tmp24_ < result_length1; _tmp24_++) {
		g_variant_builder_add_value (&_tmp23_, g_variant_new_uint32 (*_tmp22_));
		_tmp22_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp23_));
	result = (g_free (result), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	accelerators = (_vala_GalaAccelerator_array_free (accelerators, accelerators_length1), NULL);
}


static void
_dbus_gala_dbus_accelerator_ungrab_accelerator (GalaDBusAccelerator* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint action = 0U;
	GVariant* _tmp25_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp25_ = g_variant_iter_next_value (&_arguments_iter);
	action = g_variant_get_uint32 (_tmp25_);
	g_variant_unref (_tmp25_);
	result = gala_dbus_accelerator_ungrab_accelerator (self, action);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void
gala_dbus_accelerator_dbus_interface_method_call (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* method_name,
                                                  GVariant* parameters,
                                                  GDBusMethodInvocation* invocation,
                                                  gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GrabAccelerator") == 0) {
		_dbus_gala_dbus_accelerator_grab_accelerator (object, parameters, invocation);
	} else if (strcmp (method_name, "GrabAccelerators") == 0) {
		_dbus_gala_dbus_accelerator_grab_accelerators (object, parameters, invocation);
	} else if (strcmp (method_name, "UngrabAccelerator") == 0) {
		_dbus_gala_dbus_accelerator_ungrab_accelerator (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant*
gala_dbus_accelerator_dbus_interface_get_property (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* property_name,
                                                   GError** error,
                                                   gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean
gala_dbus_accelerator_dbus_interface_set_property (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* property_name,
                                                   GVariant* value,
                                                   GError** error,
                                                   gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void
_dbus_gala_dbus_accelerator_accelerator_activated (GObject* _sender,
                                                   guint action,
                                                   guint device_id,
                                                   guint timestamp,
                                                   gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (action));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (device_id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (timestamp));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.Shell", "AcceleratorActivated", _arguments, NULL);
}


guint
gala_dbus_accelerator_register_object (gpointer object,
                                       GDBusConnection* connection,
                                       const gchar* path,
                                       GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = gala_dbus_accelerator_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_gala_dbus_accelerator_dbus_interface_info), &_gala_dbus_accelerator_dbus_interface_vtable, data, _gala_dbus_accelerator_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "accelerator-activated", (GCallback) _dbus_gala_dbus_accelerator_accelerator_activated, data);
	return result;
}


static void
_gala_dbus_accelerator_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_gala_dbus_accelerator_accelerator_activated, data);
	gala_dbus_accelerator_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}



