/* DragDropAction.c generated by valac 0.40.8, the Vala compiler
 * generated from DragDropAction.vala, do not modify */

/**/
/*  Copyright (C) 2015 Deepin Technology Co., Ltd.*/
/*  Copyright (C) 2013 Tom Beckmann*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/


#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define GALA_TYPE_DRAG_DROP_ACTION_TYPE (gala_drag_drop_action_type_get_type ())

#define GALA_TYPE_DRAG_DROP_ACTION_DIRECTION (gala_drag_drop_action_direction_get_type ())

#define GALA_TYPE_DRAG_DROP_ACTION (gala_drag_drop_action_get_type ())
#define GALA_DRAG_DROP_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction))
#define GALA_DRAG_DROP_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropActionClass))
#define GALA_IS_DRAG_DROP_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DRAG_DROP_ACTION))
#define GALA_IS_DRAG_DROP_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_DRAG_DROP_ACTION))
#define GALA_DRAG_DROP_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropActionClass))

typedef struct _GalaDragDropAction GalaDragDropAction;
typedef struct _GalaDragDropActionClass GalaDragDropActionClass;
typedef struct _GalaDragDropActionPrivate GalaDragDropActionPrivate;
enum  {
	GALA_DRAG_DROP_ACTION_0_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY,
	GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY,
	GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY,
	GALA_DRAG_DROP_ACTION_NUM_PROPERTIES
};
static GParamSpec* gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_ClutterPoint_free0(var) ((var == NULL) ? NULL : (var = (_vala_ClutterPoint_free (var), NULL)))
enum  {
	GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL,
	GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL,
	GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL,
	GALA_DRAG_DROP_ACTION_DRAG_MOTION_SIGNAL,
	GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL,
	GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL,
	GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL,
	GALA_DRAG_DROP_ACTION_NUM_SIGNALS
};
static guint gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_NUM_SIGNALS] = {0};

typedef enum  {
	GALA_DRAG_DROP_ACTION_TYPE_SOURCE = 0,
	GALA_DRAG_DROP_ACTION_TYPE_DESTINATION
} GalaDragDropActionType;

typedef enum  {
	GALA_DRAG_DROP_ACTION_DIRECTION_NONE = 0,
	GALA_DRAG_DROP_ACTION_DIRECTION_LEFT = 1,
	GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT = 1 << 1,
	GALA_DRAG_DROP_ACTION_DIRECTION_UP = 1 << 2,
	GALA_DRAG_DROP_ACTION_DIRECTION_DOWN = 1 << 3,
	GALA_DRAG_DROP_ACTION_DIRECTION_ALL = ((GALA_DRAG_DROP_ACTION_DIRECTION_LEFT + GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT) + GALA_DRAG_DROP_ACTION_DIRECTION_UP) + GALA_DRAG_DROP_ACTION_DIRECTION_DOWN
} GalaDragDropActionDirection;

struct _GalaDragDropAction {
	ClutterAction parent_instance;
	GalaDragDropActionPrivate * priv;
	GalaDragDropActionDirection allow_direction;
	gfloat allow_y_overflow;
};

struct _GalaDragDropActionClass {
	ClutterActionClass parent_class;
};

struct _GalaDragDropActionPrivate {
	GalaDragDropActionType _drag_type;
	gchar* _drag_id;
	ClutterActor* _handle;
	gboolean _dragging;
	gboolean _allow_bubbling;
	ClutterActor* hovered;
	gboolean clicked;
	gfloat orig_x;
	gfloat orig_y;
	ClutterPoint* offset;
	gfloat last_x;
	gfloat last_y;
};


static gpointer gala_drag_drop_action_parent_class = NULL;
static GeeHashMap* gala_drag_drop_action_sources;
static GeeHashMap* gala_drag_drop_action_sources = NULL;

GType gala_drag_drop_action_type_get_type (void) G_GNUC_CONST;
GType gala_drag_drop_action_direction_get_type (void) G_GNUC_CONST;
GType gala_drag_drop_action_get_type (void) G_GNUC_CONST;
#define GALA_DRAG_DROP_ACTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropActionPrivate))
static void gala_drag_drop_action_release_actor (GalaDragDropAction* self,
                                          ClutterActor* actor);
static void _vala_ClutterPoint_free (ClutterPoint* self);
GalaDragDropAction* gala_drag_drop_action_new (GalaDragDropActionType type,
                                               const gchar* id);
GalaDragDropAction* gala_drag_drop_action_construct (GType object_type,
                                                     GalaDragDropActionType type,
                                                     const gchar* id);
static void gala_drag_drop_action_real_set_actor (ClutterActorMeta* base,
                                           ClutterActor* new_actor);
static void gala_drag_drop_action_connect_actor (GalaDragDropAction* self,
                                          ClutterActor* actor);
GalaDragDropActionType gala_drag_drop_action_get_drag_type (GalaDragDropAction* self);
static gboolean gala_drag_drop_action_source_clicked (GalaDragDropAction* self,
                                               ClutterButtonEvent* event);
static gboolean _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event (ClutterActor* _sender,
                                                                                 ClutterButtonEvent* event,
                                                                                 gpointer self);
const gchar* gala_drag_drop_action_get_drag_id (GalaDragDropAction* self);
static void gala_drag_drop_action_emit_crossed (GalaDragDropAction* self,
                                         ClutterActor* destination,
                                         gboolean hovered);
static GalaDragDropAction* gala_drag_drop_action_get_drag_drop_action (GalaDragDropAction* self,
                                                                ClutterActor* actor);
static gboolean gala_drag_drop_action_follow_move (GalaDragDropAction* self,
                                            ClutterEvent* event);
static gboolean _gala_drag_drop_action_follow_move_clutter_actor_captured_event (ClutterActor* _sender,
                                                                          ClutterEvent* event,
                                                                          gpointer self);
static gboolean gala_drag_drop_action_drag_allowed (GalaDragDropAction* self,
                                             ClutterEvent* event);
gboolean gala_drag_drop_action_get_dragging (GalaDragDropAction* self);
static void gala_drag_drop_action_set_handle (GalaDragDropAction* self,
                                       ClutterActor* value);
ClutterActor* gala_drag_drop_action_get_handle (GalaDragDropAction* self);
static ClutterPoint* _vala_ClutterPoint_copy (ClutterPoint* self);
static void gala_drag_drop_action_set_dragging (GalaDragDropAction* self,
                                         gboolean value);
void gala_drag_drop_action_cancel (GalaDragDropAction* self);
gboolean gala_drag_drop_action_get_allow_bubbling (GalaDragDropAction* self);
static void gala_drag_drop_action_finish (GalaDragDropAction* self);
static void gala_drag_drop_action_cleanup (GalaDragDropAction* self);
void gala_drag_drop_action_cancel_all_by_id (const gchar* id);
static void gala_drag_drop_action_set_drag_type (GalaDragDropAction* self,
                                          GalaDragDropActionType value);
static void gala_drag_drop_action_set_drag_id (GalaDragDropAction* self,
                                        const gchar* value);
void gala_drag_drop_action_set_allow_bubbling (GalaDragDropAction* self,
                                               gboolean value);
static void g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__FLOAT_FLOAT (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void gala_drag_drop_action_finalize (GObject * obj);
static void _vala_gala_drag_drop_action_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_gala_drag_drop_action_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);


GType
gala_drag_drop_action_type_get_type (void)
{
	static volatile gsize gala_drag_drop_action_type_type_id__volatile = 0;
	if (g_once_init_enter (&gala_drag_drop_action_type_type_id__volatile)) {
		static const GEnumValue values[] = {{GALA_DRAG_DROP_ACTION_TYPE_SOURCE, "GALA_DRAG_DROP_ACTION_TYPE_SOURCE", "source"}, {GALA_DRAG_DROP_ACTION_TYPE_DESTINATION, "GALA_DRAG_DROP_ACTION_TYPE_DESTINATION", "destination"}, {0, NULL, NULL}};
		GType gala_drag_drop_action_type_type_id;
		gala_drag_drop_action_type_type_id = g_enum_register_static ("GalaDragDropActionType", values);
		g_once_init_leave (&gala_drag_drop_action_type_type_id__volatile, gala_drag_drop_action_type_type_id);
	}
	return gala_drag_drop_action_type_type_id__volatile;
}


GType
gala_drag_drop_action_direction_get_type (void)
{
	static volatile gsize gala_drag_drop_action_direction_type_id__volatile = 0;
	if (g_once_init_enter (&gala_drag_drop_action_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{GALA_DRAG_DROP_ACTION_DIRECTION_NONE, "GALA_DRAG_DROP_ACTION_DIRECTION_NONE", "none"}, {GALA_DRAG_DROP_ACTION_DIRECTION_LEFT, "GALA_DRAG_DROP_ACTION_DIRECTION_LEFT", "left"}, {GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT, "GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT", "right"}, {GALA_DRAG_DROP_ACTION_DIRECTION_UP, "GALA_DRAG_DROP_ACTION_DIRECTION_UP", "up"}, {GALA_DRAG_DROP_ACTION_DIRECTION_DOWN, "GALA_DRAG_DROP_ACTION_DIRECTION_DOWN", "down"}, {GALA_DRAG_DROP_ACTION_DIRECTION_ALL, "GALA_DRAG_DROP_ACTION_DIRECTION_ALL", "all"}, {0, NULL, NULL}};
		GType gala_drag_drop_action_direction_type_id;
		gala_drag_drop_action_direction_type_id = g_enum_register_static ("GalaDragDropActionDirection", values);
		g_once_init_leave (&gala_drag_drop_action_direction_type_id__volatile, gala_drag_drop_action_direction_type_id);
	}
	return gala_drag_drop_action_direction_type_id__volatile;
}


static void
_vala_ClutterPoint_free (ClutterPoint* self)
{
#line 138 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_boxed_free (clutter_point_get_type (), self);
#line 233 "DragDropAction.c"
}


/**
 * Create a new DragDropAction
 *
 * @param type The type of this actor
 * @param id   An ID that marks which sources can be dragged on
 *             which destinations. It has to be the same for all actors that
 *             should be compatible with each other.
 */
GalaDragDropAction*
gala_drag_drop_action_construct (GType object_type,
                                 GalaDragDropActionType type,
                                 const gchar* id)
{
	GalaDragDropAction * self = NULL;
	GeeHashMap* _tmp0_;
#line 150 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 152 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	self = (GalaDragDropAction*) g_object_new (object_type, "drag-type", type, "drag-id", id, NULL);
#line 154 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = gala_drag_drop_action_sources;
#line 154 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (_tmp0_ == NULL) {
#line 260 "DragDropAction.c"
		GeeHashMap* _tmp1_;
#line 155 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LINKED_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 155 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_g_object_unref0 (gala_drag_drop_action_sources);
#line 155 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		gala_drag_drop_action_sources = _tmp1_;
#line 268 "DragDropAction.c"
	}
#line 150 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return self;
#line 272 "DragDropAction.c"
}


GalaDragDropAction*
gala_drag_drop_action_new (GalaDragDropActionType type,
                           const gchar* id)
{
#line 150 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return gala_drag_drop_action_construct (GALA_TYPE_DRAG_DROP_ACTION, type, id);
#line 282 "DragDropAction.c"
}


static void
gala_drag_drop_action_real_set_actor (ClutterActorMeta* base,
                                      ClutterActor* new_actor)
{
	GalaDragDropAction * self;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 164 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	self = (GalaDragDropAction*) base;
#line 166 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 166 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp1_ = _tmp0_;
#line 166 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (_tmp1_ != NULL) {
#line 301 "DragDropAction.c"
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
#line 167 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 167 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp3_ = _tmp2_;
#line 167 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		gala_drag_drop_action_release_actor (self, _tmp3_);
#line 310 "DragDropAction.c"
	}
#line 170 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (new_actor != NULL) {
#line 171 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		gala_drag_drop_action_connect_actor (self, new_actor);
#line 316 "DragDropAction.c"
	}
#line 174 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	CLUTTER_ACTOR_META_CLASS (gala_drag_drop_action_parent_class)->set_actor ((ClutterActorMeta*) G_TYPE_CHECK_INSTANCE_CAST (self, clutter_action_get_type (), ClutterAction), new_actor);
#line 320 "DragDropAction.c"
}


static gboolean
_gala_drag_drop_action_source_clicked_clutter_actor_button_press_event (ClutterActor* _sender,
                                                                        ClutterButtonEvent* event,
                                                                        gpointer self)
{
	gboolean result;
	result = gala_drag_drop_action_source_clicked ((GalaDragDropAction*) self, event);
#line 180 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return result;
#line 333 "DragDropAction.c"
}


static void
gala_drag_drop_action_release_actor (GalaDragDropAction* self,
                                     ClutterActor* actor)
{
	GalaDragDropActionType _tmp0_;
#line 177 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 177 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (actor != NULL);
#line 179 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = self->priv->_drag_type;
#line 179 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (_tmp0_ == GALA_DRAG_DROP_ACTION_TYPE_SOURCE) {
#line 350 "DragDropAction.c"
		guint _tmp1_;
		GeeLinkedList* source_list = NULL;
		GeeHashMap* _tmp2_;
		const gchar* _tmp3_;
		gpointer _tmp4_;
		GeeLinkedList* _tmp5_;
#line 180 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_signal_parse_name ("button-press-event", clutter_actor_get_type (), &_tmp1_, NULL, FALSE);
#line 180 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_signal_handlers_disconnect_matched (actor, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event, self);
#line 182 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp2_ = gala_drag_drop_action_sources;
#line 182 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp3_ = self->priv->_drag_id;
#line 182 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, _tmp3_);
#line 182 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		source_list = (GeeLinkedList*) _tmp4_;
#line 183 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp5_ = source_list;
#line 183 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp5_, actor);
#line 179 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_g_object_unref0 (source_list);
#line 375 "DragDropAction.c"
	}
}


static void
gala_drag_drop_action_connect_actor (GalaDragDropAction* self,
                                     ClutterActor* actor)
{
	GalaDragDropActionType _tmp0_;
#line 187 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 187 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (actor != NULL);
#line 189 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = self->priv->_drag_type;
#line 189 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (_tmp0_ == GALA_DRAG_DROP_ACTION_TYPE_SOURCE) {
#line 393 "DragDropAction.c"
		GeeLinkedList* source_list = NULL;
		GeeHashMap* _tmp1_;
		const gchar* _tmp2_;
		gpointer _tmp3_;
		GeeLinkedList* _tmp4_;
		GeeLinkedList* _tmp9_;
#line 190 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_signal_connect_object (actor, "button-press-event", (GCallback) _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event, self, 0);
#line 192 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp1_ = gala_drag_drop_action_sources;
#line 192 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp2_ = self->priv->_drag_id;
#line 192 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, _tmp2_);
#line 192 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		source_list = (GeeLinkedList*) _tmp3_;
#line 193 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp4_ = source_list;
#line 193 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		if (_tmp4_ == NULL) {
#line 414 "DragDropAction.c"
			GeeLinkedList* _tmp5_;
			GeeHashMap* _tmp6_;
			const gchar* _tmp7_;
			GeeLinkedList* _tmp8_;
#line 194 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp5_ = gee_linked_list_new (clutter_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 194 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_g_object_unref0 (source_list);
#line 194 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			source_list = _tmp5_;
#line 195 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp6_ = gala_drag_drop_action_sources;
#line 195 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp7_ = self->priv->_drag_id;
#line 195 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp8_ = source_list;
#line 195 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp7_, _tmp8_);
#line 433 "DragDropAction.c"
		}
#line 198 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp9_ = source_list;
#line 198 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, actor);
#line 189 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_g_object_unref0 (source_list);
#line 441 "DragDropAction.c"
	}
}


static void
gala_drag_drop_action_emit_crossed (GalaDragDropAction* self,
                                    ClutterActor* destination,
                                    gboolean hovered)
{
	GalaDragDropAction* _tmp0_;
	GalaDragDropAction* _tmp1_;
#line 202 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 202 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (destination != NULL);
#line 204 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = gala_drag_drop_action_get_drag_drop_action (self, destination);
#line 204 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp1_ = _tmp0_;
#line 204 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_signal_emit (_tmp1_, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL], 0, hovered);
#line 204 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_g_object_unref0 (_tmp1_);
#line 205 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL], 0, destination, hovered);
#line 467 "DragDropAction.c"
}


static gboolean
_gala_drag_drop_action_follow_move_clutter_actor_captured_event (ClutterActor* _sender,
                                                                 ClutterEvent* event,
                                                                 gpointer self)
{
	gboolean result;
	result = gala_drag_drop_action_follow_move ((GalaDragDropAction*) self, event);
#line 215 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return result;
#line 480 "DragDropAction.c"
}


static gboolean
gala_drag_drop_action_source_clicked (GalaDragDropAction* self,
                                      ClutterButtonEvent* event)
{
	gboolean result = FALSE;
	guint32 _tmp0_;
	ClutterActor* _tmp2_;
	ClutterActor* _tmp3_;
	ClutterStage* _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
#line 208 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 208 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 210 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = event->button;
#line 210 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (_tmp0_ != ((guint32) 1)) {
#line 503 "DragDropAction.c"
		guint32 _tmp1_;
#line 211 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp1_ = event->button;
#line 211 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL], 0, _tmp1_);
#line 212 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		result = FALSE;
#line 212 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		return result;
#line 513 "DragDropAction.c"
	}
#line 215 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 215 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp3_ = _tmp2_;
#line 215 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp4_ = clutter_actor_get_stage (_tmp3_);
#line 215 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_signal_connect_object ((ClutterActor*) _tmp4_, "captured-event", (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self, 0);
#line 216 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	self->priv->clicked = TRUE;
#line 217 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp5_ = event->x;
#line 217 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	self->priv->last_x = _tmp5_;
#line 218 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp6_ = event->y;
#line 218 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	self->priv->last_y = _tmp6_;
#line 220 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	result = TRUE;
#line 220 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return result;
#line 537 "DragDropAction.c"
}


static gboolean
gala_drag_drop_action_drag_allowed (GalaDragDropAction* self,
                                    ClutterEvent* event)
{
	gboolean result = FALSE;
	gfloat x = 0.0F;
	gfloat y = 0.0F;
	gfloat _tmp0_ = 0.0F;
	gfloat _tmp1_ = 0.0F;
	gint drag_threshold = 0;
	ClutterSettings* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_ = FALSE;
	GalaDragDropActionDirection _tmp6_;
	gboolean _tmp10_ = FALSE;
	GalaDragDropActionDirection _tmp11_;
	gboolean _tmp15_ = FALSE;
	GalaDragDropActionDirection _tmp16_;
	gboolean _tmp20_ = FALSE;
	GalaDragDropActionDirection _tmp21_;
	gfloat _tmp25_;
	gfloat _tmp26_;
	gfloat _tmp27_;
#line 223 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 223 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 226 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	clutter_event_get_coords (event, &_tmp0_, &_tmp1_);
#line 226 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	x = _tmp0_;
#line 226 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	y = _tmp1_;
#line 228 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp2_ = clutter_settings_get_default ();
#line 228 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_object_get (_tmp2_, "dnd-drag-threshold", &_tmp3_, NULL);
#line 228 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp4_ = _tmp3_;
#line 228 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	drag_threshold = _tmp4_;
#line 230 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp6_ = self->allow_direction;
#line 230 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if ((_tmp6_ & GALA_DRAG_DROP_ACTION_DIRECTION_LEFT) == GALA_DRAG_DROP_ACTION_DIRECTION_LEFT) {
#line 587 "DragDropAction.c"
		gfloat _tmp7_;
		gfloat _tmp8_;
		gint _tmp9_;
#line 231 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp7_ = self->priv->last_x;
#line 231 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp8_ = x;
#line 231 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp9_ = drag_threshold;
#line 231 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp5_ = (_tmp7_ - _tmp8_) > ((gfloat) _tmp9_);
#line 599 "DragDropAction.c"
	} else {
#line 230 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp5_ = FALSE;
#line 603 "DragDropAction.c"
	}
#line 230 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (_tmp5_) {
#line 232 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		result = TRUE;
#line 232 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		return result;
#line 611 "DragDropAction.c"
	}
#line 235 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp11_ = self->allow_direction;
#line 235 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if ((_tmp11_ & GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT) == GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT) {
#line 617 "DragDropAction.c"
		gfloat _tmp12_;
		gfloat _tmp13_;
		gint _tmp14_;
#line 236 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp12_ = x;
#line 236 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp13_ = self->priv->last_x;
#line 236 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp14_ = drag_threshold;
#line 236 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp10_ = (_tmp12_ - _tmp13_) > ((gfloat) _tmp14_);
#line 629 "DragDropAction.c"
	} else {
#line 235 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp10_ = FALSE;
#line 633 "DragDropAction.c"
	}
#line 235 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (_tmp10_) {
#line 237 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		result = TRUE;
#line 237 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		return result;
#line 641 "DragDropAction.c"
	}
#line 240 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp16_ = self->allow_direction;
#line 240 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if ((_tmp16_ & GALA_DRAG_DROP_ACTION_DIRECTION_UP) == GALA_DRAG_DROP_ACTION_DIRECTION_UP) {
#line 647 "DragDropAction.c"
		gfloat _tmp17_;
		gfloat _tmp18_;
		gint _tmp19_;
#line 241 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp17_ = self->priv->last_y;
#line 241 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp18_ = y;
#line 241 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp19_ = drag_threshold;
#line 241 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp15_ = (_tmp17_ - _tmp18_) > ((gfloat) _tmp19_);
#line 659 "DragDropAction.c"
	} else {
#line 240 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp15_ = FALSE;
#line 663 "DragDropAction.c"
	}
#line 240 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (_tmp15_) {
#line 242 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		result = TRUE;
#line 242 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		return result;
#line 671 "DragDropAction.c"
	}
#line 245 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp21_ = self->allow_direction;
#line 245 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if ((_tmp21_ & GALA_DRAG_DROP_ACTION_DIRECTION_DOWN) == GALA_DRAG_DROP_ACTION_DIRECTION_DOWN) {
#line 677 "DragDropAction.c"
		gfloat _tmp22_;
		gfloat _tmp23_;
		gint _tmp24_;
#line 246 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp22_ = y;
#line 246 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp23_ = self->priv->last_y;
#line 246 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp24_ = drag_threshold;
#line 246 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp20_ = (_tmp22_ - _tmp23_) > ((gfloat) _tmp24_);
#line 689 "DragDropAction.c"
	} else {
#line 245 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp20_ = FALSE;
#line 693 "DragDropAction.c"
	}
#line 245 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (_tmp20_) {
#line 247 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		result = TRUE;
#line 247 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		return result;
#line 701 "DragDropAction.c"
	}
#line 250 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp25_ = y;
#line 250 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp26_ = self->priv->last_y;
#line 250 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp27_ = self->allow_y_overflow;
#line 250 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (fabsf (_tmp25_ - _tmp26_) < _tmp27_) {
#line 251 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		result = TRUE;
#line 251 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		return result;
#line 715 "DragDropAction.c"
	}
#line 254 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	result = FALSE;
#line 254 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return result;
#line 721 "DragDropAction.c"
}


static ClutterPoint*
_vala_ClutterPoint_copy (ClutterPoint* self)
{
#line 283 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return g_boxed_copy (clutter_point_get_type (), self);
#line 730 "DragDropAction.c"
}


static gpointer
__vala_ClutterPoint_copy0 (gpointer self)
{
#line 283 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return self ? _vala_ClutterPoint_copy (self) : NULL;
#line 739 "DragDropAction.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return self ? g_object_ref (self) : NULL;
#line 748 "DragDropAction.c"
}


static gboolean
gala_drag_drop_action_follow_move (GalaDragDropAction* self,
                                   ClutterEvent* event)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 257 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 257 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 260 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = self->priv->_dragging;
#line 260 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (!_tmp0_) {
#line 261 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		switch (clutter_event_type (event)) {
#line 261 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			case CLUTTER_MOTION:
#line 770 "DragDropAction.c"
			{
				GalaDragDropActionDirection _tmp1_;
				gfloat x = 0.0F;
				gfloat y = 0.0F;
				gfloat _tmp2_ = 0.0F;
				gfloat _tmp3_ = 0.0F;
#line 263 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp1_ = self->allow_direction;
#line 263 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if (_tmp1_ == GALA_DRAG_DROP_ACTION_DIRECTION_NONE) {
#line 264 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					result = FALSE;
#line 264 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					return result;
#line 785 "DragDropAction.c"
				}
#line 268 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				clutter_event_get_coords (event, &_tmp2_, &_tmp3_);
#line 268 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				x = _tmp2_;
#line 268 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				y = _tmp3_;
#line 270 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if (gala_drag_drop_action_drag_allowed (self, event)) {
#line 795 "DragDropAction.c"
					gfloat _tmp4_;
					gfloat _tmp5_;
					ClutterActor* _tmp6_ = NULL;
					ClutterActor* _tmp7_;
					ClutterActor* _tmp8_;
					ClutterActor* _tmp13_;
					ClutterActor* _tmp14_;
					gfloat _tmp15_;
					gfloat _tmp16_;
					ClutterActor* _tmp17_;
					gfloat _tmp18_;
					gfloat _tmp19_;
					ClutterPoint* _tmp20_;
					ClutterPoint* _tmp21_;
					ClutterPoint* _tmp22_;
					gfloat _tmp23_;
					gfloat _tmp24_;
					ClutterPoint* _tmp25_;
					gfloat _tmp26_;
					gfloat _tmp27_;
					ClutterActor* _tmp28_;
					GeeLinkedList* source_list = NULL;
					GeeHashMap* _tmp29_;
					const gchar* _tmp30_;
					gpointer _tmp31_;
					GeeLinkedList* _tmp32_;
#line 271 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp4_ = x;
#line 271 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp5_ = y;
#line 271 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL], 0, _tmp4_, _tmp5_, &_tmp6_);
#line 271 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp7_ = _tmp6_;
#line 271 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					gala_drag_drop_action_set_handle (self, _tmp7_);
#line 271 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_g_object_unref0 (_tmp7_);
#line 272 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp8_ = self->priv->_handle;
#line 272 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					if (_tmp8_ == NULL) {
#line 838 "DragDropAction.c"
						ClutterActor* _tmp9_;
						ClutterActor* _tmp10_;
						ClutterStage* _tmp11_;
						guint _tmp12_;
#line 274 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						_tmp9_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 274 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						_tmp10_ = _tmp9_;
#line 274 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						_tmp11_ = clutter_actor_get_stage (_tmp10_);
#line 274 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						g_signal_parse_name ("captured-event", clutter_actor_get_type (), &_tmp12_, NULL, FALSE);
#line 274 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						g_signal_handlers_disconnect_matched ((ClutterActor*) _tmp11_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp12_, 0, NULL, (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self);
#line 275 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						result = FALSE;
#line 275 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						return result;
#line 857 "DragDropAction.c"
					}
#line 280 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp13_ = self->priv->_handle;
#line 280 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					clutter_actor_queue_relayout (_tmp13_);
#line 281 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp14_ = self->priv->_handle;
#line 281 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp15_ = clutter_actor_get_x (_tmp14_);
#line 281 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp16_ = _tmp15_;
#line 281 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					self->priv->orig_x = _tmp16_;
#line 282 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp17_ = self->priv->_handle;
#line 282 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp18_ = clutter_actor_get_y (_tmp17_);
#line 282 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp19_ = _tmp18_;
#line 282 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					self->priv->orig_y = _tmp19_;
#line 283 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp20_ = clutter_point_zero ();
#line 283 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp21_ = __vala_ClutterPoint_copy0 (_tmp20_);
#line 283 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					__vala_ClutterPoint_free0 (self->priv->offset);
#line 283 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					self->priv->offset = _tmp21_;
#line 284 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp22_ = self->priv->offset;
#line 284 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp23_ = x;
#line 284 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp24_ = self->priv->orig_x;
#line 284 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp22_->x = _tmp23_ - _tmp24_;
#line 285 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp25_ = self->priv->offset;
#line 285 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp26_ = y;
#line 285 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp27_ = self->priv->orig_y;
#line 285 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp25_->y = _tmp26_ - _tmp27_;
#line 287 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp28_ = self->priv->_handle;
#line 287 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					clutter_actor_set_reactive (_tmp28_, FALSE);
#line 289 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					self->priv->clicked = FALSE;
#line 290 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					gala_drag_drop_action_set_dragging (self, TRUE);
#line 292 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp29_ = gala_drag_drop_action_sources;
#line 292 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp30_ = self->priv->_drag_id;
#line 292 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp31_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp29_, _tmp30_);
#line 292 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					source_list = (GeeLinkedList*) _tmp31_;
#line 293 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp32_ = source_list;
#line 293 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					if (_tmp32_ != NULL) {
#line 923 "DragDropAction.c"
						{
							GeeLinkedList* _actor_list = NULL;
							GeeLinkedList* _tmp33_;
							GeeLinkedList* _tmp34_;
							gint _actor_size = 0;
							GeeLinkedList* _tmp35_;
							gint _tmp36_;
							gint _tmp37_;
							gint _actor_index = 0;
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							_tmp33_ = source_list;
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							_tmp34_ = _g_object_ref0 (_tmp33_);
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							_actor_list = _tmp34_;
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							_tmp35_ = _actor_list;
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							_tmp36_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp35_);
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							_tmp37_ = _tmp36_;
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							_actor_size = _tmp37_;
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							_actor_index = -1;
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							while (TRUE) {
#line 951 "DragDropAction.c"
								gint _tmp38_;
								gint _tmp39_;
								gint _tmp40_;
								ClutterActor* actor = NULL;
								GeeLinkedList* _tmp41_;
								gint _tmp42_;
								gpointer _tmp43_;
								ClutterActor* _tmp44_;
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
								_tmp38_ = _actor_index;
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
								_actor_index = _tmp38_ + 1;
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
								_tmp39_ = _actor_index;
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
								_tmp40_ = _actor_size;
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
								if (!(_tmp39_ < _tmp40_)) {
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
									break;
#line 972 "DragDropAction.c"
								}
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
								_tmp41_ = _actor_list;
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
								_tmp42_ = _actor_index;
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
								_tmp43_ = gee_abstract_list_get ((GeeAbstractList*) _tmp41_, _tmp42_);
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
								actor = (ClutterActor*) _tmp43_;
#line 295 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
								_tmp44_ = actor;
#line 295 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
								clutter_actor_set_reactive (_tmp44_, FALSE);
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
								_g_object_unref0 (actor);
#line 988 "DragDropAction.c"
							}
#line 294 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							_g_object_unref0 (_actor_list);
#line 992 "DragDropAction.c"
						}
					}
#line 270 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_g_object_unref0 (source_list);
#line 997 "DragDropAction.c"
				}
#line 299 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				result = TRUE;
#line 299 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				return result;
#line 1003 "DragDropAction.c"
			}
#line 261 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			case CLUTTER_BUTTON_RELEASE:
#line 1007 "DragDropAction.c"
			{
				gfloat x = 0.0F;
				gfloat y = 0.0F;
				gfloat ex = 0.0F;
				gfloat ey = 0.0F;
				gfloat _tmp45_ = 0.0F;
				gfloat _tmp46_ = 0.0F;
				ClutterActor* _tmp47_;
				ClutterActor* _tmp48_;
				gfloat _tmp49_ = 0.0F;
				gfloat _tmp50_ = 0.0F;
				gboolean _tmp51_ = FALSE;
				gboolean _tmp52_ = FALSE;
				gboolean _tmp53_ = FALSE;
				gfloat _tmp54_;
				gfloat _tmp55_;
				ClutterActor* _tmp70_;
				ClutterActor* _tmp71_;
				ClutterStage* _tmp72_;
				guint _tmp73_;
#line 302 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				clutter_event_get_coords (event, &_tmp45_, &_tmp46_);
#line 302 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				ex = _tmp45_;
#line 302 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				ey = _tmp46_;
#line 303 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp47_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 303 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp48_ = _tmp47_;
#line 303 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				clutter_actor_get_transformed_position (_tmp48_, &_tmp49_, &_tmp50_);
#line 303 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				x = _tmp49_;
#line 303 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				y = _tmp50_;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp54_ = x;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp55_ = ex;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if (_tmp54_ < _tmp55_) {
#line 1050 "DragDropAction.c"
					gfloat _tmp56_;
					ClutterActor* _tmp57_;
					ClutterActor* _tmp58_;
					gfloat _tmp59_;
					gfloat _tmp60_;
					gfloat _tmp61_;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp56_ = x;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp57_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp58_ = _tmp57_;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp59_ = clutter_actor_get_width (_tmp58_);
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp60_ = _tmp59_;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp61_ = ex;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp53_ = (_tmp56_ + _tmp60_) > _tmp61_;
#line 1071 "DragDropAction.c"
				} else {
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp53_ = FALSE;
#line 1075 "DragDropAction.c"
				}
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if (_tmp53_) {
#line 1079 "DragDropAction.c"
					gfloat _tmp62_;
					gfloat _tmp63_;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp62_ = y;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp63_ = ey;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp52_ = _tmp62_ < _tmp63_;
#line 1088 "DragDropAction.c"
				} else {
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp52_ = FALSE;
#line 1092 "DragDropAction.c"
				}
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if (_tmp52_) {
#line 1096 "DragDropAction.c"
					gfloat _tmp64_;
					ClutterActor* _tmp65_;
					ClutterActor* _tmp66_;
					gfloat _tmp67_;
					gfloat _tmp68_;
					gfloat _tmp69_;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp64_ = y;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp65_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp66_ = _tmp65_;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp67_ = clutter_actor_get_height (_tmp66_);
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp68_ = _tmp67_;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp69_ = ey;
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp51_ = (_tmp64_ + _tmp68_) > _tmp69_;
#line 1117 "DragDropAction.c"
				} else {
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp51_ = FALSE;
#line 1121 "DragDropAction.c"
				}
#line 306 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if (_tmp51_) {
#line 307 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL], 0, clutter_event_get_button (event));
#line 1127 "DragDropAction.c"
				}
#line 310 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp70_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 310 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp71_ = _tmp70_;
#line 310 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp72_ = clutter_actor_get_stage (_tmp71_);
#line 310 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				g_signal_parse_name ("captured-event", clutter_actor_get_type (), &_tmp73_, NULL, FALSE);
#line 310 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				g_signal_handlers_disconnect_matched ((ClutterActor*) _tmp72_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp73_, 0, NULL, (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self);
#line 311 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				self->priv->clicked = FALSE;
#line 312 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				gala_drag_drop_action_set_dragging (self, FALSE);
#line 313 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				result = TRUE;
#line 313 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				return result;
#line 1147 "DragDropAction.c"
			}
			default:
			{
#line 315 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				result = TRUE;
#line 315 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				return result;
#line 1155 "DragDropAction.c"
			}
		}
	}
#line 319 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	switch (clutter_event_type (event)) {
#line 319 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		case CLUTTER_KEY_PRESS:
#line 1163 "DragDropAction.c"
		{
#line 321 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if (((gint) clutter_event_get_key_code (event)) == CLUTTER_KEY_Escape) {
#line 322 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				gala_drag_drop_action_cancel (self);
#line 1169 "DragDropAction.c"
			}
#line 324 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			result = TRUE;
#line 324 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			return result;
#line 1175 "DragDropAction.c"
		}
#line 319 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		case CLUTTER_MOTION:
#line 1179 "DragDropAction.c"
		{
			gfloat x = 0.0F;
			gfloat y = 0.0F;
			gfloat _tmp74_ = 0.0F;
			gfloat _tmp75_ = 0.0F;
			GalaDragDropActionDirection _tmp76_;
			GalaDragDropActionDirection _tmp85_;
			GalaDragDropActionDirection _tmp94_;
			GalaDragDropActionDirection _tmp103_;
			gfloat _tmp112_;
			gboolean _tmp123_ = FALSE;
			ClutterActor* _tmp124_;
			gfloat _tmp125_;
			gfloat _tmp126_;
			gfloat _tmp127_;
			ClutterStage* stage = NULL;
			ClutterActor* _tmp140_;
			ClutterActor* _tmp141_;
			ClutterStage* _tmp142_;
			ClutterStage* _tmp143_;
			ClutterActor* actor = NULL;
			ClutterStage* _tmp144_;
			gfloat _tmp145_;
			gfloat _tmp146_;
			ClutterActor* _tmp147_;
			ClutterActor* _tmp148_;
			GalaDragDropAction* action = NULL;
			gboolean _tmp149_ = FALSE;
			gboolean _tmp150_ = FALSE;
			gboolean _tmp151_ = FALSE;
			ClutterActor* _tmp152_;
			ClutterActor* _tmp167_;
			ClutterActor* _tmp168_;
			GalaDragDropAction* _tmp169_;
			ClutterActor* _tmp172_;
			ClutterActor* _tmp174_;
			ClutterActor* _tmp175_;
			ClutterActor* _tmp176_;
#line 328 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			clutter_event_get_coords (event, &_tmp74_, &_tmp75_);
#line 328 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			x = _tmp74_;
#line 328 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			y = _tmp75_;
#line 331 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp76_ = self->allow_direction;
#line 331 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if ((_tmp76_ & GALA_DRAG_DROP_ACTION_DIRECTION_LEFT) == GALA_DRAG_DROP_ACTION_DIRECTION_LEFT) {
#line 1228 "DragDropAction.c"
				gfloat _tmp77_;
				ClutterPoint* _tmp78_;
				gfloat _tmp79_;
				gfloat _tmp80_;
#line 333 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp77_ = x;
#line 333 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp78_ = self->priv->offset;
#line 333 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp79_ = _tmp78_->x;
#line 333 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp80_ = self->priv->orig_x;
#line 333 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if ((_tmp77_ - _tmp79_) <= _tmp80_) {
#line 1243 "DragDropAction.c"
					ClutterActor* _tmp81_;
					gfloat _tmp82_;
					ClutterPoint* _tmp83_;
					gfloat _tmp84_;
#line 334 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp81_ = self->priv->_handle;
#line 334 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp82_ = x;
#line 334 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp83_ = self->priv->offset;
#line 334 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp84_ = _tmp83_->x;
#line 334 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					clutter_actor_set_x (_tmp81_, _tmp82_ - _tmp84_);
#line 1258 "DragDropAction.c"
				}
			}
#line 337 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp85_ = self->allow_direction;
#line 337 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if ((_tmp85_ & GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT) == GALA_DRAG_DROP_ACTION_DIRECTION_RIGHT) {
#line 1265 "DragDropAction.c"
				gfloat _tmp86_;
				ClutterPoint* _tmp87_;
				gfloat _tmp88_;
				gfloat _tmp89_;
#line 339 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp86_ = x;
#line 339 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp87_ = self->priv->offset;
#line 339 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp88_ = _tmp87_->x;
#line 339 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp89_ = self->priv->orig_x;
#line 339 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if ((_tmp86_ - _tmp88_) >= _tmp89_) {
#line 1280 "DragDropAction.c"
					ClutterActor* _tmp90_;
					gfloat _tmp91_;
					ClutterPoint* _tmp92_;
					gfloat _tmp93_;
#line 340 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp90_ = self->priv->_handle;
#line 340 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp91_ = x;
#line 340 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp92_ = self->priv->offset;
#line 340 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp93_ = _tmp92_->x;
#line 340 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					clutter_actor_set_x (_tmp90_, _tmp91_ - _tmp93_);
#line 1295 "DragDropAction.c"
				}
			}
#line 343 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp94_ = self->allow_direction;
#line 343 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if ((_tmp94_ & GALA_DRAG_DROP_ACTION_DIRECTION_UP) == GALA_DRAG_DROP_ACTION_DIRECTION_UP) {
#line 1302 "DragDropAction.c"
				gfloat _tmp95_;
				ClutterPoint* _tmp96_;
				gfloat _tmp97_;
				gfloat _tmp98_;
#line 345 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp95_ = y;
#line 345 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp96_ = self->priv->offset;
#line 345 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp97_ = _tmp96_->y;
#line 345 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp98_ = self->priv->orig_y;
#line 345 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if ((_tmp95_ - _tmp97_) <= _tmp98_) {
#line 1317 "DragDropAction.c"
					ClutterActor* _tmp99_;
					gfloat _tmp100_;
					ClutterPoint* _tmp101_;
					gfloat _tmp102_;
#line 346 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp99_ = self->priv->_handle;
#line 346 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp100_ = y;
#line 346 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp101_ = self->priv->offset;
#line 346 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp102_ = _tmp101_->y;
#line 346 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					clutter_actor_set_y (_tmp99_, _tmp100_ - _tmp102_);
#line 1332 "DragDropAction.c"
				}
			}
#line 349 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp103_ = self->allow_direction;
#line 349 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if ((_tmp103_ & GALA_DRAG_DROP_ACTION_DIRECTION_DOWN) == GALA_DRAG_DROP_ACTION_DIRECTION_DOWN) {
#line 1339 "DragDropAction.c"
				gfloat _tmp104_;
				ClutterPoint* _tmp105_;
				gfloat _tmp106_;
				gfloat _tmp107_;
#line 351 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp104_ = y;
#line 351 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp105_ = self->priv->offset;
#line 351 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp106_ = _tmp105_->y;
#line 351 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp107_ = self->priv->orig_y;
#line 351 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if ((_tmp104_ - _tmp106_) >= _tmp107_) {
#line 1354 "DragDropAction.c"
					ClutterActor* _tmp108_;
					gfloat _tmp109_;
					ClutterPoint* _tmp110_;
					gfloat _tmp111_;
#line 352 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp108_ = self->priv->_handle;
#line 352 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp109_ = y;
#line 352 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp110_ = self->priv->offset;
#line 352 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp111_ = _tmp110_->y;
#line 352 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					clutter_actor_set_y (_tmp108_, _tmp109_ - _tmp111_);
#line 1369 "DragDropAction.c"
				}
			}
#line 356 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp112_ = self->allow_y_overflow;
#line 356 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if (_tmp112_ > 0.0f) {
#line 1376 "DragDropAction.c"
				gfloat d = 0.0F;
				gfloat _tmp113_;
				ClutterPoint* _tmp114_;
				gfloat _tmp115_;
				gfloat _tmp116_;
				gfloat _tmp117_;
				gfloat _tmp118_;
#line 357 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp113_ = y;
#line 357 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp114_ = self->priv->offset;
#line 357 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp115_ = _tmp114_->y;
#line 357 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp116_ = self->priv->orig_y;
#line 357 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				d = (_tmp113_ - _tmp115_) - _tmp116_;
#line 358 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp117_ = d;
#line 358 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp118_ = self->allow_y_overflow;
#line 358 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if (_tmp117_ < _tmp118_) {
#line 1400 "DragDropAction.c"
					ClutterActor* _tmp119_;
					gfloat _tmp120_;
					ClutterPoint* _tmp121_;
					gfloat _tmp122_;
#line 359 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp119_ = self->priv->_handle;
#line 359 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp120_ = y;
#line 359 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp121_ = self->priv->offset;
#line 359 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp122_ = _tmp121_->y;
#line 359 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					clutter_actor_set_y (_tmp119_, _tmp120_ - _tmp122_);
#line 1415 "DragDropAction.c"
				}
			}
#line 362 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp124_ = self->priv->_handle;
#line 362 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp125_ = clutter_actor_get_x (_tmp124_);
#line 362 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp126_ = _tmp125_;
#line 362 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp127_ = self->priv->orig_x;
#line 362 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if (_tmp126_ != _tmp127_) {
#line 362 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp123_ = TRUE;
#line 1430 "DragDropAction.c"
			} else {
				ClutterActor* _tmp128_;
				gfloat _tmp129_;
				gfloat _tmp130_;
				gfloat _tmp131_;
#line 362 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp128_ = self->priv->_handle;
#line 362 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp129_ = clutter_actor_get_y (_tmp128_);
#line 362 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp130_ = _tmp129_;
#line 362 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp131_ = self->priv->orig_y;
#line 362 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp123_ = _tmp130_ != _tmp131_;
#line 1446 "DragDropAction.c"
			}
#line 362 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if (_tmp123_) {
#line 1450 "DragDropAction.c"
				ClutterActor* _tmp132_;
				gfloat _tmp133_;
				gfloat _tmp134_;
				gfloat _tmp135_;
				ClutterActor* _tmp136_;
				gfloat _tmp137_;
				gfloat _tmp138_;
				gfloat _tmp139_;
#line 363 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp132_ = self->priv->_handle;
#line 363 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp133_ = clutter_actor_get_x (_tmp132_);
#line 363 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp134_ = _tmp133_;
#line 363 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp135_ = self->priv->orig_x;
#line 363 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp136_ = self->priv->_handle;
#line 363 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp137_ = clutter_actor_get_y (_tmp136_);
#line 363 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp138_ = _tmp137_;
#line 363 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp139_ = self->priv->orig_y;
#line 363 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_MOTION_SIGNAL], 0, _tmp134_ - _tmp135_, _tmp138_ - _tmp139_);
#line 1477 "DragDropAction.c"
			}
#line 365 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp140_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 365 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp141_ = _tmp140_;
#line 365 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp142_ = clutter_actor_get_stage (_tmp141_);
#line 365 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp143_ = _g_object_ref0 (_tmp142_);
#line 365 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			stage = _tmp143_;
#line 366 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp144_ = stage;
#line 366 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp145_ = x;
#line 366 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp146_ = y;
#line 366 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp147_ = clutter_stage_get_actor_at_pos (_tmp144_, CLUTTER_PICK_REACTIVE, (gint) _tmp145_, (gint) _tmp146_);
#line 366 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp148_ = _g_object_ref0 (_tmp147_);
#line 366 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			actor = _tmp148_;
#line 367 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			action = NULL;
#line 369 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp152_ = actor;
#line 369 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if (_tmp152_ != NULL) {
#line 1507 "DragDropAction.c"
				ClutterActor* _tmp153_;
				ClutterStage* _tmp154_;
#line 369 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp153_ = actor;
#line 369 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp154_ = stage;
#line 369 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp151_ = _tmp153_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp154_, clutter_actor_get_type (), ClutterActor);
#line 1516 "DragDropAction.c"
			} else {
#line 369 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp151_ = FALSE;
#line 1520 "DragDropAction.c"
			}
#line 369 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if (_tmp151_) {
#line 1524 "DragDropAction.c"
				ClutterActor* _tmp155_;
				GalaDragDropAction* _tmp156_;
				GalaDragDropAction* _tmp157_;
#line 370 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp155_ = actor;
#line 370 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp156_ = gala_drag_drop_action_get_drag_drop_action (self, _tmp155_);
#line 370 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_g_object_unref0 (action);
#line 370 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				action = _tmp156_;
#line 370 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp157_ = action;
#line 370 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp150_ = _tmp157_ == NULL;
#line 1540 "DragDropAction.c"
			} else {
#line 369 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp150_ = FALSE;
#line 1544 "DragDropAction.c"
			}
#line 369 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if (_tmp150_) {
#line 1548 "DragDropAction.c"
				gboolean _tmp158_;
#line 370 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp158_ = self->priv->_allow_bubbling;
#line 370 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp149_ = _tmp158_;
#line 1554 "DragDropAction.c"
			} else {
#line 369 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp149_ = FALSE;
#line 1558 "DragDropAction.c"
			}
#line 369 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if (_tmp149_) {
#line 371 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				while (TRUE) {
#line 1564 "DragDropAction.c"
					ClutterActor* _tmp159_;
					ClutterActor* _tmp160_;
					ClutterActor* _tmp161_;
					ClutterActor* _tmp162_;
					ClutterStage* _tmp163_;
					ClutterActor* _tmp164_;
					GalaDragDropAction* _tmp165_;
					GalaDragDropAction* _tmp166_;
#line 371 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp159_ = actor;
#line 371 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp160_ = clutter_actor_get_parent (_tmp159_);
#line 371 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp161_ = _g_object_ref0 (_tmp160_);
#line 371 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_g_object_unref0 (actor);
#line 371 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					actor = _tmp161_;
#line 371 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp162_ = actor;
#line 371 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp163_ = stage;
#line 371 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					if (!(_tmp162_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp163_, clutter_actor_get_type (), ClutterActor))) {
#line 371 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						break;
#line 1591 "DragDropAction.c"
					}
#line 372 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp164_ = actor;
#line 372 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp165_ = gala_drag_drop_action_get_drag_drop_action (self, _tmp164_);
#line 372 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_g_object_unref0 (action);
#line 372 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					action = _tmp165_;
#line 372 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp166_ = action;
#line 372 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					if (_tmp166_ != NULL) {
#line 373 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						break;
#line 1607 "DragDropAction.c"
					}
				}
			}
#line 378 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp167_ = actor;
#line 378 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp168_ = self->priv->hovered;
#line 378 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if (_tmp167_ == _tmp168_) {
#line 379 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				result = TRUE;
#line 379 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_g_object_unref0 (action);
#line 379 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_g_object_unref0 (actor);
#line 379 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_g_object_unref0 (stage);
#line 379 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				return result;
#line 1627 "DragDropAction.c"
			}
#line 381 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp169_ = action;
#line 381 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if (_tmp169_ == NULL) {
#line 1633 "DragDropAction.c"
				ClutterActor* _tmp170_;
#line 383 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp170_ = self->priv->hovered;
#line 383 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if (_tmp170_ != NULL) {
#line 1639 "DragDropAction.c"
					ClutterActor* _tmp171_;
#line 384 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp171_ = self->priv->hovered;
#line 384 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					gala_drag_drop_action_emit_crossed (self, _tmp171_, FALSE);
#line 385 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_g_object_unref0 (self->priv->hovered);
#line 385 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					self->priv->hovered = NULL;
#line 1649 "DragDropAction.c"
				}
#line 388 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				result = TRUE;
#line 388 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_g_object_unref0 (action);
#line 388 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_g_object_unref0 (actor);
#line 388 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_g_object_unref0 (stage);
#line 388 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				return result;
#line 1661 "DragDropAction.c"
			}
#line 392 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp172_ = self->priv->hovered;
#line 392 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if (_tmp172_ != NULL) {
#line 1667 "DragDropAction.c"
				ClutterActor* _tmp173_;
#line 393 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp173_ = self->priv->hovered;
#line 393 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				gala_drag_drop_action_emit_crossed (self, _tmp173_, FALSE);
#line 1673 "DragDropAction.c"
			}
#line 397 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp174_ = actor;
#line 397 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp175_ = _g_object_ref0 (_tmp174_);
#line 397 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_g_object_unref0 (self->priv->hovered);
#line 397 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			self->priv->hovered = _tmp175_;
#line 398 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp176_ = self->priv->hovered;
#line 398 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			gala_drag_drop_action_emit_crossed (self, _tmp176_, TRUE);
#line 400 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			result = TRUE;
#line 400 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_g_object_unref0 (action);
#line 400 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_g_object_unref0 (actor);
#line 400 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_g_object_unref0 (stage);
#line 400 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			return result;
#line 1697 "DragDropAction.c"
		}
#line 319 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		case CLUTTER_BUTTON_RELEASE:
#line 1701 "DragDropAction.c"
		{
			ClutterActor* _tmp177_;
#line 402 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp177_ = self->priv->hovered;
#line 402 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if (_tmp177_ != NULL) {
#line 403 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				gala_drag_drop_action_finish (self);
#line 1710 "DragDropAction.c"
			} else {
#line 405 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				gala_drag_drop_action_cancel (self);
#line 1714 "DragDropAction.c"
			}
#line 407 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			result = TRUE;
#line 407 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			return result;
#line 1720 "DragDropAction.c"
		}
#line 319 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		case CLUTTER_ENTER:
#line 319 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		case CLUTTER_LEAVE:
#line 1726 "DragDropAction.c"
		{
#line 410 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			result = TRUE;
#line 410 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			return result;
#line 1732 "DragDropAction.c"
		}
		default:
#line 319 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		break;
#line 1737 "DragDropAction.c"
	}
#line 413 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	result = FALSE;
#line 413 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return result;
#line 1743 "DragDropAction.c"
}


/**
 * Looks for a DragDropAction instance if this actor has one or NULL.
 * It also checks if it is a DESTINATION and if the id matches
 *
 * @return the DragDropAction instance on this actor or NULL
 */
static GalaDragDropAction*
gala_drag_drop_action_get_drag_drop_action (GalaDragDropAction* self,
                                            ClutterActor* actor)
{
	GalaDragDropAction* result = NULL;
	GalaDragDropAction* drop_action = NULL;
	GList* _tmp0_;
#line 422 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 422 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_val_if_fail (actor != NULL, NULL);
#line 424 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	drop_action = NULL;
#line 426 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = clutter_actor_get_actions (actor);
#line 1768 "DragDropAction.c"
	{
		GList* action_collection = NULL;
		GList* action_it = NULL;
#line 426 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		action_collection = _tmp0_;
#line 426 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		for (action_it = action_collection; action_it != NULL; action_it = action_it->next) {
#line 1776 "DragDropAction.c"
			ClutterAction* action = NULL;
#line 426 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			action = (ClutterAction*) action_it->data;
#line 1780 "DragDropAction.c"
			{
				ClutterAction* _tmp1_;
				GalaDragDropAction* _tmp2_;
				gboolean _tmp3_ = FALSE;
				gboolean _tmp4_ = FALSE;
				GalaDragDropAction* _tmp5_;
#line 427 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp1_ = action;
#line 427 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, GALA_TYPE_DRAG_DROP_ACTION) ? ((GalaDragDropAction*) _tmp1_) : NULL);
#line 427 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_g_object_unref0 (drop_action);
#line 427 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				drop_action = _tmp2_;
#line 428 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp5_ = drop_action;
#line 428 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if (_tmp5_ == NULL) {
#line 428 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp4_ = TRUE;
#line 1801 "DragDropAction.c"
				} else {
					GalaDragDropAction* _tmp6_;
					GalaDragDropActionType _tmp7_;
#line 429 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp6_ = drop_action;
#line 429 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp7_ = _tmp6_->priv->_drag_type;
#line 429 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp4_ = _tmp7_ != GALA_DRAG_DROP_ACTION_TYPE_DESTINATION;
#line 1811 "DragDropAction.c"
				}
#line 428 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if (_tmp4_) {
#line 428 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp3_ = TRUE;
#line 1817 "DragDropAction.c"
				} else {
					GalaDragDropAction* _tmp8_;
					const gchar* _tmp9_;
					const gchar* _tmp10_;
#line 430 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp8_ = drop_action;
#line 430 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp9_ = _tmp8_->priv->_drag_id;
#line 430 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp10_ = self->priv->_drag_id;
#line 430 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					_tmp3_ = g_strcmp0 (_tmp9_, _tmp10_) != 0;
#line 1830 "DragDropAction.c"
				}
#line 428 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if (_tmp3_) {
#line 431 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					continue;
#line 1836 "DragDropAction.c"
				}
#line 433 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				result = drop_action;
#line 433 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				(action_collection == NULL) ? NULL : (action_collection = (g_list_free (action_collection), NULL));
#line 433 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				return result;
#line 1844 "DragDropAction.c"
			}
		}
#line 426 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		(action_collection == NULL) ? NULL : (action_collection = (g_list_free (action_collection), NULL));
#line 1849 "DragDropAction.c"
	}
#line 436 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	result = NULL;
#line 436 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_g_object_unref0 (drop_action);
#line 436 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return result;
#line 1857 "DragDropAction.c"
}


/**
 * Abort the drag
 */
void
gala_drag_drop_action_cancel (GalaDragDropAction* self)
{
#line 442 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 444 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	gala_drag_drop_action_cleanup (self);
#line 446 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL], 0);
#line 1873 "DragDropAction.c"
}


/**
 * Allows you to abort all drags currently running for a given drag-id
 */
void
gala_drag_drop_action_cancel_all_by_id (const gchar* id)
{
	GeeLinkedList* actors = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GeeLinkedList* _tmp2_;
#line 452 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (id != NULL);
#line 454 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = gala_drag_drop_action_sources;
#line 454 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, id);
#line 454 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	actors = (GeeLinkedList*) _tmp1_;
#line 455 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp2_ = actors;
#line 455 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (_tmp2_ == NULL) {
#line 456 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_g_object_unref0 (actors);
#line 456 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		return;
#line 1903 "DragDropAction.c"
	}
	{
		GeeLinkedList* _actor_list = NULL;
		GeeLinkedList* _tmp3_;
		GeeLinkedList* _tmp4_;
		gint _actor_size = 0;
		GeeLinkedList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _actor_index = 0;
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp3_ = actors;
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_actor_list = _tmp4_;
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp5_ = _actor_list;
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp7_ = _tmp6_;
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_actor_size = _tmp7_;
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_actor_index = -1;
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		while (TRUE) {
#line 1932 "DragDropAction.c"
			gint _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			ClutterActor* actor = NULL;
			GeeLinkedList* _tmp11_;
			gint _tmp12_;
			gpointer _tmp13_;
			ClutterActor* _tmp14_;
			GList* _tmp15_;
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp8_ = _actor_index;
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_actor_index = _tmp8_ + 1;
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp9_ = _actor_index;
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp10_ = _actor_size;
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			if (!(_tmp9_ < _tmp10_)) {
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				break;
#line 1954 "DragDropAction.c"
			}
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp11_ = _actor_list;
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp12_ = _actor_index;
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _tmp12_);
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			actor = (ClutterActor*) _tmp13_;
#line 459 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp14_ = actor;
#line 459 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp15_ = clutter_actor_get_actions (_tmp14_);
#line 1968 "DragDropAction.c"
			{
				GList* action_collection = NULL;
				GList* action_it = NULL;
#line 459 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				action_collection = _tmp15_;
#line 459 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				for (action_it = action_collection; action_it != NULL; action_it = action_it->next) {
#line 1976 "DragDropAction.c"
					ClutterAction* action = NULL;
#line 459 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					action = (ClutterAction*) action_it->data;
#line 1980 "DragDropAction.c"
					{
						GalaDragDropAction* drag_action = NULL;
						ClutterAction* _tmp16_;
						GalaDragDropAction* _tmp17_;
						gboolean _tmp18_ = FALSE;
						GalaDragDropAction* _tmp19_;
#line 460 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						_tmp16_ = action;
#line 460 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, GALA_TYPE_DRAG_DROP_ACTION) ? ((GalaDragDropAction*) _tmp16_) : NULL);
#line 460 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						drag_action = _tmp17_;
#line 461 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						_tmp19_ = drag_action;
#line 461 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						if (_tmp19_ != NULL) {
#line 1997 "DragDropAction.c"
							GalaDragDropAction* _tmp20_;
							gboolean _tmp21_;
#line 461 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							_tmp20_ = drag_action;
#line 461 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							_tmp21_ = _tmp20_->priv->_dragging;
#line 461 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							_tmp18_ = _tmp21_;
#line 2006 "DragDropAction.c"
						} else {
#line 461 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							_tmp18_ = FALSE;
#line 2010 "DragDropAction.c"
						}
#line 461 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						if (_tmp18_) {
#line 2014 "DragDropAction.c"
							GalaDragDropAction* _tmp22_;
#line 462 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							_tmp22_ = drag_action;
#line 462 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							gala_drag_drop_action_cancel (_tmp22_);
#line 463 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							_g_object_unref0 (drag_action);
#line 463 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
							break;
#line 2024 "DragDropAction.c"
						}
#line 459 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
						_g_object_unref0 (drag_action);
#line 2028 "DragDropAction.c"
					}
				}
#line 459 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				(action_collection == NULL) ? NULL : (action_collection = (g_list_free (action_collection), NULL));
#line 2033 "DragDropAction.c"
			}
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_g_object_unref0 (actor);
#line 2037 "DragDropAction.c"
		}
#line 458 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_g_object_unref0 (_actor_list);
#line 2041 "DragDropAction.c"
	}
#line 452 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_g_object_unref0 (actors);
#line 2045 "DragDropAction.c"
}


static void
gala_drag_drop_action_finish (GalaDragDropAction* self)
{
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 469 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 472 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = self->priv->hovered;
#line 472 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	gala_drag_drop_action_emit_crossed (self, _tmp0_, FALSE);
#line 474 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	gala_drag_drop_action_cleanup (self);
#line 476 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp1_ = self->priv->hovered;
#line 476 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL], 0, _tmp1_);
#line 2066 "DragDropAction.c"
}


static void
gala_drag_drop_action_cleanup (GalaDragDropAction* self)
{
	GeeLinkedList* source_list = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	GeeLinkedList* _tmp3_;
	gboolean _tmp16_;
#line 479 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 481 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = gala_drag_drop_action_sources;
#line 481 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp1_ = self->priv->_drag_id;
#line 481 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 481 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	source_list = (GeeLinkedList*) _tmp2_;
#line 482 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp3_ = source_list;
#line 482 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (_tmp3_ != NULL) {
#line 2093 "DragDropAction.c"
		{
			GeeLinkedList* _actor_list = NULL;
			GeeLinkedList* _tmp4_;
			GeeLinkedList* _tmp5_;
			gint _actor_size = 0;
			GeeLinkedList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _actor_index = 0;
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp4_ = source_list;
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_actor_list = _tmp5_;
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp6_ = _actor_list;
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_tmp8_ = _tmp7_;
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_actor_size = _tmp8_;
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_actor_index = -1;
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			while (TRUE) {
#line 2121 "DragDropAction.c"
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				ClutterActor* actor = NULL;
				GeeLinkedList* _tmp12_;
				gint _tmp13_;
				gpointer _tmp14_;
				ClutterActor* _tmp15_;
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp9_ = _actor_index;
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_actor_index = _tmp9_ + 1;
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp10_ = _actor_index;
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp11_ = _actor_size;
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				if (!(_tmp10_ < _tmp11_)) {
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
					break;
#line 2142 "DragDropAction.c"
				}
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp12_ = _actor_list;
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp13_ = _actor_index;
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _tmp13_);
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				actor = (ClutterActor*) _tmp14_;
#line 484 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_tmp15_ = actor;
#line 484 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				clutter_actor_set_reactive (_tmp15_, TRUE);
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
				_g_object_unref0 (actor);
#line 2158 "DragDropAction.c"
			}
#line 483 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
			_g_object_unref0 (_actor_list);
#line 2162 "DragDropAction.c"
		}
	}
#line 488 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp16_ = self->priv->_dragging;
#line 488 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (_tmp16_) {
#line 2169 "DragDropAction.c"
		ClutterActor* _tmp17_;
		ClutterActor* _tmp18_;
		ClutterStage* _tmp19_;
		guint _tmp20_;
#line 489 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp17_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 489 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp18_ = _tmp17_;
#line 489 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp19_ = clutter_actor_get_stage (_tmp18_);
#line 489 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_signal_parse_name ("captured-event", clutter_actor_get_type (), &_tmp20_, NULL, FALSE);
#line 489 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_signal_handlers_disconnect_matched ((ClutterActor*) _tmp19_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp20_, 0, NULL, (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self);
#line 2184 "DragDropAction.c"
	}
#line 491 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	gala_drag_drop_action_set_dragging (self, FALSE);
#line 479 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_g_object_unref0 (source_list);
#line 2190 "DragDropAction.c"
}


GalaDragDropActionType
gala_drag_drop_action_get_drag_type (GalaDragDropAction* self)
{
	GalaDragDropActionType result;
	GalaDragDropActionType _tmp0_;
#line 100 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 100 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = self->priv->_drag_type;
#line 100 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	result = _tmp0_;
#line 100 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return result;
#line 2207 "DragDropAction.c"
}


static void
gala_drag_drop_action_set_drag_type (GalaDragDropAction* self,
                                     GalaDragDropActionType value)
{
#line 100 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 100 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (gala_drag_drop_action_get_drag_type (self) != value) {
#line 100 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		self->priv->_drag_type = value;
#line 100 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY]);
#line 2223 "DragDropAction.c"
	}
}


const gchar*
gala_drag_drop_action_get_drag_id (GalaDragDropAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 105 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 105 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = self->priv->_drag_id;
#line 105 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	result = _tmp0_;
#line 105 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return result;
#line 2241 "DragDropAction.c"
}


static void
gala_drag_drop_action_set_drag_id (GalaDragDropAction* self,
                                   const gchar* value)
{
#line 105 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 105 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (g_strcmp0 (value, gala_drag_drop_action_get_drag_id (self)) != 0) {
#line 2253 "DragDropAction.c"
		gchar* _tmp0_;
#line 105 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp0_ = g_strdup (value);
#line 105 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_g_free0 (self->priv->_drag_id);
#line 105 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		self->priv->_drag_id = _tmp0_;
#line 105 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY]);
#line 2263 "DragDropAction.c"
	}
}


ClutterActor*
gala_drag_drop_action_get_handle (GalaDragDropAction* self)
{
	ClutterActor* result;
	ClutterActor* _tmp0_;
#line 107 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = self->priv->_handle;
#line 107 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	result = _tmp0_;
#line 107 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return result;
#line 2281 "DragDropAction.c"
}


static void
gala_drag_drop_action_set_handle (GalaDragDropAction* self,
                                  ClutterActor* value)
{
#line 107 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 107 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (gala_drag_drop_action_get_handle (self) != value) {
#line 2293 "DragDropAction.c"
		ClutterActor* _tmp0_;
#line 107 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 107 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_g_object_unref0 (self->priv->_handle);
#line 107 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		self->priv->_handle = _tmp0_;
#line 107 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY]);
#line 2303 "DragDropAction.c"
	}
}


gboolean
gala_drag_drop_action_get_dragging (GalaDragDropAction* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = self->priv->_dragging;
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	result = _tmp0_;
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return result;
#line 2321 "DragDropAction.c"
}


static void
gala_drag_drop_action_set_dragging (GalaDragDropAction* self,
                                    gboolean value)
{
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (gala_drag_drop_action_get_dragging (self) != value) {
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		self->priv->_dragging = value;
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY]);
#line 2337 "DragDropAction.c"
	}
}


gboolean
gala_drag_drop_action_get_allow_bubbling (GalaDragDropAction* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 117 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 117 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = self->priv->_allow_bubbling;
#line 117 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	result = _tmp0_;
#line 117 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	return result;
#line 2355 "DragDropAction.c"
}


void
gala_drag_drop_action_set_allow_bubbling (GalaDragDropAction* self,
                                          gboolean value)
{
#line 117 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 117 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (gala_drag_drop_action_get_allow_bubbling (self) != value) {
#line 117 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		self->priv->_allow_bubbling = value;
#line 117 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY]);
#line 2371 "DragDropAction.c"
	}
}


static void
g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef gpointer (*GMarshalFunc_OBJECT__FLOAT_FLOAT) (gpointer data1, gfloat arg_1, gfloat arg_2, gpointer data2);
	register GMarshalFunc_OBJECT__FLOAT_FLOAT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gpointer v_return;
	cc = (GCClosure *) closure;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (return_value != NULL);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (n_param_values == 3);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		data1 = closure->data;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		data2 = param_values->data[0].v_pointer;
#line 2401 "DragDropAction.c"
	} else {
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		data1 = param_values->data[0].v_pointer;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		data2 = closure->data;
#line 2407 "DragDropAction.c"
	}
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	callback = (GMarshalFunc_OBJECT__FLOAT_FLOAT) (marshal_data ? marshal_data : cc->callback);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	v_return = callback (data1, g_value_get_float (param_values + 1), g_value_get_float (param_values + 2), data2);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_value_take_object (return_value, v_return);
#line 2415 "DragDropAction.c"
}


static void
g_cclosure_user_marshal_VOID__FLOAT_FLOAT (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__FLOAT_FLOAT) (gpointer data1, gfloat arg_1, gfloat arg_2, gpointer data2);
	register GMarshalFunc_VOID__FLOAT_FLOAT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (n_param_values == 3);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		data1 = closure->data;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		data2 = param_values->data[0].v_pointer;
#line 2441 "DragDropAction.c"
	} else {
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		data1 = param_values->data[0].v_pointer;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		data2 = closure->data;
#line 2447 "DragDropAction.c"
	}
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	callback = (GMarshalFunc_VOID__FLOAT_FLOAT) (marshal_data ? marshal_data : cc->callback);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	callback (data1, g_value_get_float (param_values + 1), g_value_get_float (param_values + 2), data2);
#line 2453 "DragDropAction.c"
}


static void
g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_return_if_fail (n_param_values == 3);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		data1 = closure->data;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		data2 = param_values->data[0].v_pointer;
#line 2479 "DragDropAction.c"
	} else {
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		data1 = param_values->data[0].v_pointer;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		data2 = closure->data;
#line 2485 "DragDropAction.c"
	}
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	callback = (GMarshalFunc_VOID__OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 2491 "DragDropAction.c"
}


static void
gala_drag_drop_action_class_init (GalaDragDropActionClass * klass)
{
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	gala_drag_drop_action_parent_class = g_type_class_peek_parent (klass);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_type_class_add_private (klass, sizeof (GalaDragDropActionPrivate));
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	((ClutterActorMetaClass *) klass)->set_actor = (void (*) (ClutterActorMeta *, ClutterActor*)) gala_drag_drop_action_real_set_actor;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_drag_drop_action_get_property;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_drag_drop_action_set_property;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_drag_drop_action_finalize;
#line 2510 "DragDropAction.c"
	/**
	 * The type of the action
	 */
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY] = g_param_spec_enum ("drag-type", "drag-type", "drag-type", GALA_TYPE_DRAG_DROP_ACTION_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2516 "DragDropAction.c"
	/**
	 * The unique id given to this drag-drop-group
	 */
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY] = g_param_spec_string ("drag-id", "drag-id", "drag-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY] = g_param_spec_object ("handle", "handle", "handle", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2524 "DragDropAction.c"
	/**
	 * Indicates whether a drag action is currently active
	 */
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY] = g_param_spec_boolean ("dragging", "dragging", "dragging", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2530 "DragDropAction.c"
	/**
	 * Allow checking the parents of reactive children if they are valid destinations
	 * if the child is none
	 */
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY] = g_param_spec_boolean ("allow-bubbling", "allow-bubbling", "allow-bubbling", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2537 "DragDropAction.c"
	/**
	 * A drag has been started. You have to connect to this signal and
	 * return an actor that is transformed during the drag operation.
	 *
	 * @param x The global x coordinate where the action was activated
	 * @param y The global y coordinate where the action was activated
	 * @return  A ClutterActor that serves as handle
	 */
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL] = g_signal_new ("drag-begin", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT, clutter_actor_get_type (), 2, G_TYPE_FLOAT, G_TYPE_FLOAT);
#line 2548 "DragDropAction.c"
	/**
	 * A drag has been canceled. You may want to consider cleaning up
	 * your handle.
	 */
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL] = g_signal_new ("drag-canceled", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2555 "DragDropAction.c"
	/**
	 * A drag action has successfully been finished.
	 *
	 * @param actor The actor on which the drag finished
	 */
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL] = g_signal_new ("drag-end", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, clutter_actor_get_type ());
#line 2563 "DragDropAction.c"
	/**
	 * A drag action is moving mouse
	 *
	 * @param delta_x is the dragging distance in x-axis
	 * @param delta_y is the dragging distance in y-axis
	 */
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_MOTION_SIGNAL] = g_signal_new ("drag-motion", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__FLOAT_FLOAT, G_TYPE_NONE, 2, G_TYPE_FLOAT, G_TYPE_FLOAT);
#line 2572 "DragDropAction.c"
	/**
	 * The destination has been crossed
	 *
	 * @param hovered indicates whether the actor is now hovered or not
	 */
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL] = g_signal_new ("crossed", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 2580 "DragDropAction.c"
	/**
	 * Emitted on the source when a destination is crossed.
	 *
	 * @param destination The destination actor that has been crossed
	 * @param hovered     Whether the actor is now hovered or has just been left
	 */
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL] = g_signal_new ("destination-crossed", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN, G_TYPE_NONE, 2, clutter_actor_get_type (), G_TYPE_BOOLEAN);
#line 2589 "DragDropAction.c"
	/**
	 * The source has been clicked, but the movement was not larger than
	 * the drag threshold. Useful if the source is also activable.
	 *
	 * @param button The button which was pressed
	 */
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL] = g_signal_new ("actor-clicked", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
#line 2598 "DragDropAction.c"
}


static void
gala_drag_drop_action_instance_init (GalaDragDropAction * self)
{
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	self->priv = GALA_DRAG_DROP_ACTION_GET_PRIVATE (self);
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	self->priv->_dragging = FALSE;
#line 117 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	self->priv->_allow_bubbling = TRUE;
#line 122 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	self->allow_direction = GALA_DRAG_DROP_ACTION_DIRECTION_ALL;
#line 128 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	self->allow_y_overflow = 0.0f;
#line 131 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	self->priv->hovered = NULL;
#line 132 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	self->priv->clicked = FALSE;
#line 2619 "DragDropAction.c"
}


static void
gala_drag_drop_action_finalize (GObject * obj)
{
	GalaDragDropAction * self;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
#line 160 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp0_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 160 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_tmp1_ = _tmp0_;
#line 160 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	if (_tmp1_ != NULL) {
#line 2637 "DragDropAction.c"
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
#line 161 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 161 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		_tmp3_ = _tmp2_;
#line 161 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		gala_drag_drop_action_release_actor (self, _tmp3_);
#line 2646 "DragDropAction.c"
	}
#line 105 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_g_free0 (self->priv->_drag_id);
#line 107 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_g_object_unref0 (self->priv->_handle);
#line 131 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	_g_object_unref0 (self->priv->hovered);
#line 138 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	__vala_ClutterPoint_free0 (self->priv->offset);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	G_OBJECT_CLASS (gala_drag_drop_action_parent_class)->finalize (obj);
#line 2658 "DragDropAction.c"
}


GType
gala_drag_drop_action_get_type (void)
{
	static volatile gsize gala_drag_drop_action_type_id__volatile = 0;
	if (g_once_init_enter (&gala_drag_drop_action_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaDragDropActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_drag_drop_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaDragDropAction), 0, (GInstanceInitFunc) gala_drag_drop_action_instance_init, NULL };
		GType gala_drag_drop_action_type_id;
		gala_drag_drop_action_type_id = g_type_register_static (clutter_action_get_type (), "GalaDragDropAction", &g_define_type_info, 0);
		g_once_init_leave (&gala_drag_drop_action_type_id__volatile, gala_drag_drop_action_type_id);
	}
	return gala_drag_drop_action_type_id__volatile;
}


static void
_vala_gala_drag_drop_action_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	GalaDragDropAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	switch (property_id) {
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY:
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_value_set_enum (value, gala_drag_drop_action_get_drag_type (self));
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		break;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY:
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_value_set_string (value, gala_drag_drop_action_get_drag_id (self));
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		break;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY:
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_value_set_object (value, gala_drag_drop_action_get_handle (self));
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		break;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY:
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_value_set_boolean (value, gala_drag_drop_action_get_dragging (self));
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		break;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY:
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		g_value_set_boolean (value, gala_drag_drop_action_get_allow_bubbling (self));
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		break;
#line 2716 "DragDropAction.c"
		default:
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		break;
#line 2722 "DragDropAction.c"
	}
}


static void
_vala_gala_drag_drop_action_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	GalaDragDropAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
	switch (property_id) {
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY:
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		gala_drag_drop_action_set_drag_type (self, g_value_get_enum (value));
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		break;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY:
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		gala_drag_drop_action_set_drag_id (self, g_value_get_string (value));
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		break;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY:
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		gala_drag_drop_action_set_handle (self, g_value_get_object (value));
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		break;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY:
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		gala_drag_drop_action_set_dragging (self, g_value_get_boolean (value));
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		break;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY:
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		gala_drag_drop_action_set_allow_bubbling (self, g_value_get_boolean (value));
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		break;
#line 2767 "DragDropAction.c"
		default:
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/DragDropAction.vala"
		break;
#line 2773 "DragDropAction.c"
	}
}



