/* WorkspaceManager.c generated by valac 0.40.8, the Vala compiler
 * generated from WorkspaceManager.vala, do not modify */

/**/
/*  Copyright (C) 2015 Deepin Technology Co., Ltd.*/
/*  Copyright (C) 2014 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/


#include <glib.h>
#include <glib-object.h>
#include "gala.h"
#include <gee.h>
#include <meta/workspace.h>
#include <meta/screen.h>
#include <meta/meta-plugin.h>
#include <meta/prefs.h>
#include <meta/common.h>
#include <meta/window.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <meta/display.h>


#define GALA_TYPE_WORKSPACE_MANAGER (gala_workspace_manager_get_type ())
#define GALA_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager))
#define GALA_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))
#define GALA_IS_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_IS_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_WORKSPACE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))

typedef struct _GalaWorkspaceManager GalaWorkspaceManager;
typedef struct _GalaWorkspaceManagerClass GalaWorkspaceManagerClass;
typedef struct _GalaWorkspaceManagerPrivate GalaWorkspaceManagerPrivate;
enum  {
	GALA_WORKSPACE_MANAGER_0_PROPERTY,
	GALA_WORKSPACE_MANAGER_WM_PROPERTY,
	GALA_WORKSPACE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GALA_TYPE_BEHAVIOR_SETTINGS (gala_behavior_settings_get_type ())
#define GALA_BEHAVIOR_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_BEHAVIOR_SETTINGS, GalaBehaviorSettings))
#define GALA_BEHAVIOR_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_BEHAVIOR_SETTINGS, GalaBehaviorSettingsClass))
#define GALA_IS_BEHAVIOR_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_BEHAVIOR_SETTINGS))
#define GALA_IS_BEHAVIOR_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_BEHAVIOR_SETTINGS))
#define GALA_BEHAVIOR_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_BEHAVIOR_SETTINGS, GalaBehaviorSettingsClass))

typedef struct _GalaBehaviorSettings GalaBehaviorSettings;
typedef struct _GalaBehaviorSettingsClass GalaBehaviorSettingsClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GalaWorkspaceManager {
	GObject parent_instance;
	GalaWorkspaceManagerPrivate * priv;
};

struct _GalaWorkspaceManagerClass {
	GObjectClass parent_class;
};

struct _GalaWorkspaceManagerPrivate {
	GalaWindowManager* _wm;
	GeeLinkedList* workspaces_marked_removed;
	gint remove_freeze_count;
};


static gpointer gala_workspace_manager_parent_class = NULL;
static GalaWorkspaceManager* gala_workspace_manager_instance;
static GalaWorkspaceManager* gala_workspace_manager_instance = NULL;

GType gala_workspace_manager_get_type (void) G_GNUC_CONST;
#define GALA_WORKSPACE_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerPrivate))
GalaWindowManager* gala_workspace_manager_get_wm (GalaWorkspaceManager* self);
static void gala_workspace_manager_prefs_listener (GalaWorkspaceManager* self,
                                            MetaPreference pref);
static void _gala_workspace_manager_prefs_listener_meta_prefs_changed_func (MetaPreference pref,
                                                                     gpointer self);
static void gala_workspace_manager_workspace_added (GalaWorkspaceManager* self,
                                             MetaScreen* screen,
                                             gint index);
static void _gala_workspace_manager_workspace_added_meta_screen_workspace_added (MetaScreen* _sender,
                                                                          gint object,
                                                                          gpointer self);
static void gala_workspace_manager_workspace_switched (GalaWorkspaceManager* self,
                                                MetaScreen* screen,
                                                gint from,
                                                gint to,
                                                MetaMotionDirection direction);
static void _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched (MetaScreen* _sender,
                                                                                gint object,
                                                                                gint p0,
                                                                                MetaMotionDirection p1,
                                                                                gpointer self);
static void gala_workspace_manager_workspace_removed (GalaWorkspaceManager* self,
                                               MetaScreen* screen,
                                               gint index);
static void _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed (MetaScreen* _sender,
                                                                              gint object,
                                                                              gpointer self);
static void gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self,
                                                    MetaScreen* screen,
                                                    gint monitor,
                                                    MetaWindow* window);
static void _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor (MetaScreen* _sender,
                                                                                        gint object,
                                                                                        MetaWindow* p0,
                                                                                        gpointer self);
static void gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self,
                                                 MetaScreen* screen,
                                                 gint monitor,
                                                 MetaWindow* window);
static void _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor (MetaScreen* _sender,
                                                                                  gint object,
                                                                                  MetaWindow* p0,
                                                                                  gpointer self);
void gala_workspace_manager_init (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_new (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_construct (GType object_type,
                                                        GalaWindowManager* wm);
GalaWorkspaceManager* gala_workspace_manager_get_default (void);
static void gala_workspace_manager_window_added (GalaWorkspaceManager* self,
                                          MetaWorkspace* workspace,
                                          MetaWindow* window);
static void _gala_workspace_manager_window_added_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                       MetaWindow* object,
                                                                       gpointer self);
static void gala_workspace_manager_window_removed (GalaWorkspaceManager* self,
                                            MetaWorkspace* workspace,
                                            MetaWindow* window);
static void _gala_workspace_manager_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                           MetaWindow* object,
                                                                           gpointer self);
static void gala_workspace_manager_remove_workspace (GalaWorkspaceManager* self,
                                              MetaWorkspace* workspace);
GType gala_behavior_settings_get_type (void) G_GNUC_CONST;
GalaBehaviorSettings* gala_behavior_settings_get_default (void);
gchar** gala_behavior_settings_get_auto_focus_windows (GalaBehaviorSettings* self,
                                                       int* result_length1);
static void gala_workspace_manager_append_workspace (GalaWorkspaceManager* self);
gboolean gala_internal_utils_workspaces_only_on_primary (void);
void gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self);
void gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self);
void gala_workspace_manager_cleanup (GalaWorkspaceManager* self);
static void gala_workspace_manager_set_wm (GalaWorkspaceManager* self,
                                    GalaWindowManager* value);
static GObject * gala_workspace_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void gala_workspace_manager_finalize (GObject * obj);
static void _vala_gala_workspace_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_gala_workspace_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);


static void
_gala_workspace_manager_prefs_listener_meta_prefs_changed_func (MetaPreference pref,
                                                                gpointer self)
{
#line 79 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	gala_workspace_manager_prefs_listener ((GalaWorkspaceManager*) self, pref);
#line 188 "WorkspaceManager.c"
}


static void
_gala_workspace_manager_workspace_added_meta_screen_workspace_added (MetaScreen* _sender,
                                                                     gint object,
                                                                     gpointer self)
{
#line 81 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	gala_workspace_manager_workspace_added ((GalaWorkspaceManager*) self, _sender, object);
#line 199 "WorkspaceManager.c"
}


static void
_gala_workspace_manager_workspace_switched_meta_screen_workspace_switched (MetaScreen* _sender,
                                                                           gint object,
                                                                           gint p0,
                                                                           MetaMotionDirection p1,
                                                                           gpointer self)
{
#line 82 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	gala_workspace_manager_workspace_switched ((GalaWorkspaceManager*) self, _sender, object, p0, p1);
#line 212 "WorkspaceManager.c"
}


static void
_gala_workspace_manager_workspace_removed_meta_screen_workspace_removed (MetaScreen* _sender,
                                                                         gint object,
                                                                         gpointer self)
{
#line 83 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	gala_workspace_manager_workspace_removed ((GalaWorkspaceManager*) self, _sender, object);
#line 223 "WorkspaceManager.c"
}


static void
_gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor (MetaScreen* _sender,
                                                                                   gint object,
                                                                                   MetaWindow* p0,
                                                                                   gpointer self)
{
#line 84 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	gala_workspace_manager_window_entered_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
#line 235 "WorkspaceManager.c"
}


static void
_gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor (MetaScreen* _sender,
                                                                             gint object,
                                                                             MetaWindow* p0,
                                                                             gpointer self)
{
#line 85 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	gala_workspace_manager_window_left_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
#line 247 "WorkspaceManager.c"
}


void
gala_workspace_manager_init (GalaWindowManager* wm)
{
	GalaWorkspaceManager* _tmp0_;
	GalaWorkspaceManager* _tmp1_;
#line 25 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (wm != NULL);
#line 25 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp0_ = gala_workspace_manager_instance;
#line 25 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_vala_return_if_fail (_tmp0_ == NULL, "instance == null");
#line 28 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp1_ = gala_workspace_manager_new (wm);
#line 28 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_g_object_unref0 (gala_workspace_manager_instance);
#line 28 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	gala_workspace_manager_instance = _tmp1_;
#line 268 "WorkspaceManager.c"
}


GalaWorkspaceManager*
gala_workspace_manager_get_default (void)
{
	GalaWorkspaceManager* result = NULL;
	GalaWorkspaceManager* _tmp0_;
	GalaWorkspaceManager* _tmp1_;
#line 31 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp0_ = gala_workspace_manager_instance;
#line 31 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "instance != null", NULL);
#line 34 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp1_ = gala_workspace_manager_instance;
#line 34 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	result = _tmp1_;
#line 34 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	return result;
#line 288 "WorkspaceManager.c"
}


static GalaWorkspaceManager*
gala_workspace_manager_construct (GType object_type,
                                  GalaWindowManager* wm)
{
	GalaWorkspaceManager * self = NULL;
#line 44 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 46 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	self = (GalaWorkspaceManager*) g_object_new (object_type, "wm", wm, NULL);
#line 44 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	return self;
#line 303 "WorkspaceManager.c"
}


static GalaWorkspaceManager*
gala_workspace_manager_new (GalaWindowManager* wm)
{
#line 44 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	return gala_workspace_manager_construct (GALA_TYPE_WORKSPACE_MANAGER, wm);
#line 312 "WorkspaceManager.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 90 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 321 "WorkspaceManager.c"
}


static void
_gala_workspace_manager_window_added_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                  MetaWindow* object,
                                                                  gpointer self)
{
#line 94 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	gala_workspace_manager_window_added ((GalaWorkspaceManager*) self, _sender, object);
#line 332 "WorkspaceManager.c"
}


static void
_gala_workspace_manager_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                      MetaWindow* object,
                                                                      gpointer self)
{
#line 95 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	gala_workspace_manager_window_removed ((GalaWorkspaceManager*) self, _sender, object);
#line 343 "WorkspaceManager.c"
}


static void
gala_workspace_manager_workspace_added (GalaWorkspaceManager* self,
                                        MetaScreen* screen,
                                        gint index)
{
	MetaWorkspace* workspace = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	MetaWorkspace* _tmp2_;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* _tmp4_;
#line 88 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 88 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 90 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp0_ = meta_screen_get_workspace_by_index (screen, index);
#line 90 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 90 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	workspace = _tmp1_;
#line 91 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp2_ = workspace;
#line 91 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp2_ == NULL) {
#line 92 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_g_object_unref0 (workspace);
#line 92 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		return;
#line 376 "WorkspaceManager.c"
	}
#line 94 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp3_ = workspace;
#line 94 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp3_, "window-added", (GCallback) _gala_workspace_manager_window_added_meta_workspace_window_added, self, 0);
#line 95 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp4_ = workspace;
#line 95 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp4_, "window-removed", (GCallback) _gala_workspace_manager_window_removed_meta_workspace_window_removed, self, 0);
#line 88 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_g_object_unref0 (workspace);
#line 388 "WorkspaceManager.c"
}


static void
gala_workspace_manager_workspace_removed (GalaWorkspaceManager* self,
                                          MetaScreen* screen,
                                          gint index)
{
	GList* existing_workspaces = NULL;
	GList* _tmp0_;
	GeeIterator* it = NULL;
	GeeLinkedList* _tmp1_;
	GeeIterator* _tmp2_;
#line 98 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 98 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 100 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp0_ = meta_screen_get_workspaces (screen);
#line 100 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	existing_workspaces = _tmp0_;
#line 102 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp1_ = self->priv->workspaces_marked_removed;
#line 102 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
#line 102 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	it = _tmp2_;
#line 103 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	while (TRUE) {
#line 418 "WorkspaceManager.c"
		GeeIterator* _tmp3_;
		GList* _tmp4_;
		GeeIterator* _tmp5_;
		gpointer _tmp6_;
		MetaWorkspace* _tmp7_;
		gboolean _tmp8_;
#line 103 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp3_ = it;
#line 103 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		if (!gee_iterator_next (_tmp3_)) {
#line 103 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			break;
#line 431 "WorkspaceManager.c"
		}
#line 104 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp4_ = existing_workspaces;
#line 104 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp5_ = it;
#line 104 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp6_ = gee_iterator_get (_tmp5_);
#line 104 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp7_ = (MetaWorkspace*) _tmp6_;
#line 104 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp8_ = g_list_index (_tmp4_, _tmp7_) < 0;
#line 104 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_g_object_unref0 (_tmp7_);
#line 104 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		if (_tmp8_) {
#line 447 "WorkspaceManager.c"
			GeeIterator* _tmp9_;
#line 105 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			_tmp9_ = it;
#line 105 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			gee_iterator_remove (_tmp9_);
#line 453 "WorkspaceManager.c"
		}
	}
#line 98 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_g_object_unref0 (it);
#line 458 "WorkspaceManager.c"
}


static void
gala_workspace_manager_workspace_switched (GalaWorkspaceManager* self,
                                           MetaScreen* screen,
                                           gint from,
                                           gint to,
                                           MetaMotionDirection direction)
{
	MetaWorkspace* prev_workspace = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	gboolean _tmp2_ = FALSE;
	MetaWorkspace* _tmp3_;
#line 109 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 109 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 111 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (!meta_prefs_get_dynamic_workspaces ()) {
#line 112 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		return;
#line 482 "WorkspaceManager.c"
	}
#line 115 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp0_ = meta_screen_get_workspace_by_index (screen, from);
#line 115 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 115 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	prev_workspace = _tmp1_;
#line 116 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp3_ = prev_workspace;
#line 116 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (gala_utils_get_n_windows (_tmp3_) < ((guint) 1)) {
#line 117 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp2_ = from != (meta_screen_get_n_workspaces (screen) - 1);
#line 496 "WorkspaceManager.c"
	} else {
#line 116 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp2_ = FALSE;
#line 500 "WorkspaceManager.c"
	}
#line 116 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp2_) {
#line 504 "WorkspaceManager.c"
		MetaWorkspace* _tmp4_;
#line 118 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp4_ = prev_workspace;
#line 118 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		gala_workspace_manager_remove_workspace (self, _tmp4_);
#line 510 "WorkspaceManager.c"
	}
#line 109 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_g_object_unref0 (prev_workspace);
#line 514 "WorkspaceManager.c"
}


static void
gala_workspace_manager_window_added (GalaWorkspaceManager* self,
                                     MetaWorkspace* workspace,
                                     MetaWindow* window)
{
	MetaScreen* screen = NULL;
	MetaScreen* _tmp0_;
	GalaBehaviorSettings* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	MetaWindowType _tmp21_;
	MetaWindowType _tmp22_;
#line 122 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 122 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 124 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp0_ = meta_workspace_get_screen (workspace);
#line 124 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	screen = _tmp0_;
#line 127 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp1_ = gala_behavior_settings_get_default ();
#line 127 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp2_ = gala_behavior_settings_get_auto_focus_windows (_tmp1_, &_tmp2__length1);
#line 127 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp3_ = _tmp2_;
#line 127 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp3__length1 = _tmp2__length1;
#line 553 "WorkspaceManager.c"
	{
		gchar** w_collection = NULL;
		gint w_collection_length1 = 0;
		gint _w_collection_size_ = 0;
		gint w_it = 0;
#line 127 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		w_collection = _tmp3_;
#line 127 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		w_collection_length1 = _tmp3__length1;
#line 127 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		for (w_it = 0; w_it < _tmp3__length1; w_it = w_it + 1) {
#line 565 "WorkspaceManager.c"
			gchar* _tmp4_;
			gchar* w = NULL;
#line 127 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			_tmp4_ = g_strdup (w_collection[w_it]);
#line 127 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			w = _tmp4_;
#line 572 "WorkspaceManager.c"
			{
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				const gchar* _tmp7_;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
#line 128 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				_tmp7_ = w;
#line 128 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				_tmp8_ = meta_window_get_wm_class (window);
#line 128 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				_tmp9_ = _tmp8_;
#line 128 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				if (g_strcmp0 (_tmp7_, _tmp9_) == 0) {
#line 587 "WorkspaceManager.c"
					MetaWindowType _tmp10_;
					MetaWindowType _tmp11_;
#line 128 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					_tmp10_ = meta_window_get_window_type (window);
#line 128 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					_tmp11_ = _tmp10_;
#line 128 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					_tmp6_ = _tmp11_ == META_WINDOW_NORMAL;
#line 596 "WorkspaceManager.c"
				} else {
#line 128 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					_tmp6_ = FALSE;
#line 600 "WorkspaceManager.c"
				}
#line 128 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				if (_tmp6_) {
#line 129 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					_tmp5_ = meta_window_showing_on_its_workspace (window);
#line 606 "WorkspaceManager.c"
				} else {
#line 128 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					_tmp5_ = FALSE;
#line 610 "WorkspaceManager.c"
				}
#line 128 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				if (_tmp5_) {
#line 614 "WorkspaceManager.c"
					MetaScreen* _tmp12_;
					MetaDisplay* _tmp13_;
#line 130 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					_tmp12_ = screen;
#line 130 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					_tmp13_ = meta_screen_get_display (_tmp12_);
#line 130 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					meta_window_activate (window, meta_display_get_current_time (_tmp13_));
#line 131 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					_g_free0 (w);
#line 131 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					break;
#line 627 "WorkspaceManager.c"
				}
#line 127 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				_g_free0 (w);
#line 631 "WorkspaceManager.c"
			}
		}
	}
#line 135 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (workspace == NULL) {
#line 135 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp15_ = TRUE;
#line 639 "WorkspaceManager.c"
	} else {
#line 135 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp15_ = !meta_prefs_get_dynamic_workspaces ();
#line 643 "WorkspaceManager.c"
	}
#line 135 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp15_) {
#line 135 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp14_ = TRUE;
#line 649 "WorkspaceManager.c"
	} else {
		gboolean _tmp16_;
		gboolean _tmp17_;
#line 136 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		g_object_get (window, "on-all-workspaces", &_tmp16_, NULL);
#line 136 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp17_ = _tmp16_;
#line 136 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp14_ = _tmp17_;
#line 659 "WorkspaceManager.c"
	}
#line 135 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp14_) {
#line 137 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		return;
#line 665 "WorkspaceManager.c"
	}
#line 139 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp21_ = meta_window_get_window_type (window);
#line 139 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp22_ = _tmp21_;
#line 139 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp22_ == META_WINDOW_NORMAL) {
#line 139 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp20_ = TRUE;
#line 675 "WorkspaceManager.c"
	} else {
		MetaWindowType _tmp23_;
		MetaWindowType _tmp24_;
#line 140 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp23_ = meta_window_get_window_type (window);
#line 140 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp24_ = _tmp23_;
#line 140 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp20_ = _tmp24_ == META_WINDOW_DIALOG;
#line 685 "WorkspaceManager.c"
	}
#line 139 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp20_) {
#line 139 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp19_ = TRUE;
#line 691 "WorkspaceManager.c"
	} else {
		MetaWindowType _tmp25_;
		MetaWindowType _tmp26_;
#line 141 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp25_ = meta_window_get_window_type (window);
#line 141 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp26_ = _tmp25_;
#line 141 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp19_ = _tmp26_ == META_WINDOW_MODAL_DIALOG;
#line 701 "WorkspaceManager.c"
	}
#line 139 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp19_) {
#line 705 "WorkspaceManager.c"
		MetaScreen* _tmp27_;
#line 142 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp27_ = screen;
#line 142 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp18_ = meta_workspace_index (workspace) == (meta_screen_get_n_workspaces (_tmp27_) - 1);
#line 711 "WorkspaceManager.c"
	} else {
#line 139 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp18_ = FALSE;
#line 715 "WorkspaceManager.c"
	}
#line 139 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp18_) {
#line 143 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		gala_workspace_manager_append_workspace (self);
#line 721 "WorkspaceManager.c"
	}
}


static void
gala_workspace_manager_window_removed (GalaWorkspaceManager* self,
                                       MetaWorkspace* workspace,
                                       MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
	MetaScreen* screen = NULL;
	MetaScreen* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	MetaWindowType _tmp4_;
	MetaWindowType _tmp5_;
	gint index = 0;
	MetaScreen* _tmp10_;
	GList* _tmp11_;
	gint _tmp12_;
	gboolean is_active_workspace = FALSE;
	MetaScreen* _tmp13_;
	MetaWorkspace* _tmp14_;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_;
#line 146 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 146 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 148 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (workspace == NULL) {
#line 148 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp0_ = TRUE;
#line 758 "WorkspaceManager.c"
	} else {
#line 148 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp0_ = !meta_prefs_get_dynamic_workspaces ();
#line 762 "WorkspaceManager.c"
	}
#line 148 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 149 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		return;
#line 768 "WorkspaceManager.c"
	}
#line 151 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp1_ = meta_workspace_get_screen (workspace);
#line 151 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	screen = _tmp1_;
#line 153 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp4_ = meta_window_get_window_type (window);
#line 153 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp5_ = _tmp4_;
#line 153 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp5_ != META_WINDOW_NORMAL) {
#line 780 "WorkspaceManager.c"
		MetaWindowType _tmp6_;
		MetaWindowType _tmp7_;
#line 154 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp6_ = meta_window_get_window_type (window);
#line 154 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp7_ = _tmp6_;
#line 154 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp3_ = _tmp7_ != META_WINDOW_DIALOG;
#line 789 "WorkspaceManager.c"
	} else {
#line 153 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp3_ = FALSE;
#line 793 "WorkspaceManager.c"
	}
#line 153 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp3_) {
#line 797 "WorkspaceManager.c"
		MetaWindowType _tmp8_;
		MetaWindowType _tmp9_;
#line 155 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp8_ = meta_window_get_window_type (window);
#line 155 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp9_ = _tmp8_;
#line 155 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp2_ = _tmp9_ != META_WINDOW_MODAL_DIALOG;
#line 806 "WorkspaceManager.c"
	} else {
#line 153 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp2_ = FALSE;
#line 810 "WorkspaceManager.c"
	}
#line 153 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp2_) {
#line 156 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		return;
#line 816 "WorkspaceManager.c"
	}
#line 158 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp10_ = screen;
#line 158 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp11_ = meta_screen_get_workspaces (_tmp10_);
#line 158 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	index = g_list_index (_tmp11_, workspace);
#line 160 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp12_ = index;
#line 160 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp12_ < 0) {
#line 161 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		return;
#line 830 "WorkspaceManager.c"
	}
#line 163 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp13_ = screen;
#line 163 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp14_ = meta_screen_get_active_workspace (_tmp13_);
#line 163 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	is_active_workspace = workspace == _tmp14_;
#line 167 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp19_ = is_active_workspace;
#line 167 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (!_tmp19_) {
#line 167 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp18_ = TRUE;
#line 844 "WorkspaceManager.c"
	} else {
		GalaWindowManager* _tmp20_;
#line 167 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp20_ = self->priv->_wm;
#line 167 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp18_ = gala_window_manager_is_modal (_tmp20_);
#line 851 "WorkspaceManager.c"
	}
#line 167 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp18_) {
#line 855 "WorkspaceManager.c"
		gint _tmp21_;
#line 168 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp21_ = self->priv->remove_freeze_count;
#line 168 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp17_ = _tmp21_ < 1;
#line 861 "WorkspaceManager.c"
	} else {
#line 167 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp17_ = FALSE;
#line 865 "WorkspaceManager.c"
	}
#line 167 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp17_) {
#line 169 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp16_ = gala_utils_get_n_windows (workspace) < ((guint) 1);
#line 871 "WorkspaceManager.c"
	} else {
#line 167 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp16_ = FALSE;
#line 875 "WorkspaceManager.c"
	}
#line 167 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp16_) {
#line 879 "WorkspaceManager.c"
		gint _tmp22_;
		MetaScreen* _tmp23_;
#line 170 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp22_ = index;
#line 170 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp23_ = screen;
#line 170 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp15_ = _tmp22_ != (meta_screen_get_n_workspaces (_tmp23_) - 1);
#line 888 "WorkspaceManager.c"
	} else {
#line 167 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp15_ = FALSE;
#line 892 "WorkspaceManager.c"
	}
#line 167 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp15_) {
#line 171 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		gala_workspace_manager_remove_workspace (self, workspace);
#line 898 "WorkspaceManager.c"
	}
}


static void
gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self,
                                               MetaScreen* screen,
                                               gint monitor,
                                               MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
#line 175 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 175 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 175 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 177 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (gala_internal_utils_workspaces_only_on_primary ()) {
#line 178 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp0_ = monitor == meta_screen_get_primary_monitor (screen);
#line 920 "WorkspaceManager.c"
	} else {
#line 177 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp0_ = FALSE;
#line 924 "WorkspaceManager.c"
	}
#line 177 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 928 "WorkspaceManager.c"
		MetaWorkspace* _tmp1_;
#line 179 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp1_ = meta_window_get_workspace (window);
#line 179 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		gala_workspace_manager_window_added (self, _tmp1_, window);
#line 934 "WorkspaceManager.c"
	}
}


static void
gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self,
                                            MetaScreen* screen,
                                            gint monitor,
                                            MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
#line 182 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 182 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 182 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 184 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (gala_internal_utils_workspaces_only_on_primary ()) {
#line 185 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp0_ = monitor == meta_screen_get_primary_monitor (screen);
#line 956 "WorkspaceManager.c"
	} else {
#line 184 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp0_ = FALSE;
#line 960 "WorkspaceManager.c"
	}
#line 184 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 964 "WorkspaceManager.c"
		MetaWorkspace* _tmp1_;
#line 186 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp1_ = meta_window_get_workspace (window);
#line 186 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		gala_workspace_manager_window_removed (self, _tmp1_, window);
#line 970 "WorkspaceManager.c"
	}
}


static void
gala_workspace_manager_prefs_listener (GalaWorkspaceManager* self,
                                       MetaPreference pref)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 189 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 191 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 191 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 191 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	screen = _tmp1_;
#line 193 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (pref == META_PREF_DYNAMIC_WORKSPACES) {
#line 193 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp2_ = meta_prefs_get_dynamic_workspaces ();
#line 995 "WorkspaceManager.c"
	} else {
#line 193 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp2_ = FALSE;
#line 999 "WorkspaceManager.c"
	}
#line 193 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp2_) {
#line 1003 "WorkspaceManager.c"
		MetaScreen* _tmp3_;
		MetaScreen* _tmp4_;
		MetaWorkspace* _tmp5_;
#line 195 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp3_ = screen;
#line 195 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp4_ = screen;
#line 195 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp5_ = meta_screen_get_workspace_by_index (_tmp3_, meta_screen_get_n_workspaces (_tmp4_) - 1);
#line 195 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		if (gala_utils_get_n_windows (_tmp5_) > ((guint) 0)) {
#line 196 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			gala_workspace_manager_append_workspace (self);
#line 1017 "WorkspaceManager.c"
		}
	}
}


static void
gala_workspace_manager_append_workspace (GalaWorkspaceManager* self)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
#line 200 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 202 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 202 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 202 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	screen = _tmp1_;
#line 204 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp2_ = meta_screen_get_display (screen);
#line 204 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	meta_screen_append_new_workspace (screen, FALSE, meta_display_get_current_time (_tmp2_));
#line 1042 "WorkspaceManager.c"
}


/**
 * Make sure we switch to a different workspace and remove the given one
 *
 * @param workspace The workspace to remove
 */
static void
gala_workspace_manager_remove_workspace (GalaWorkspaceManager* self,
                                         MetaWorkspace* workspace)
{
	MetaScreen* screen = NULL;
	MetaScreen* _tmp0_;
	guint32 time = 0U;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
	MetaScreen* _tmp3_;
	MetaWorkspace* _tmp4_;
	GeeLinkedList* _tmp15_;
	guint _tmp16_;
	guint _tmp17_;
	GeeLinkedList* _tmp18_;
	MetaScreen* _tmp19_;
	guint32 _tmp20_;
#line 212 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 212 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (workspace != NULL);
#line 214 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp0_ = meta_workspace_get_screen (workspace);
#line 214 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	screen = _tmp0_;
#line 216 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp1_ = screen;
#line 216 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp2_ = meta_screen_get_display (_tmp1_);
#line 216 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	time = meta_display_get_current_time (_tmp2_);
#line 218 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp3_ = screen;
#line 218 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp4_ = meta_screen_get_active_workspace (_tmp3_);
#line 218 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (workspace == _tmp4_) {
#line 1088 "WorkspaceManager.c"
		MetaWorkspace* next = NULL;
		MetaWorkspace* _tmp5_;
		MetaWorkspace* _tmp6_;
		gboolean _tmp7_ = FALSE;
		MetaWorkspace* _tmp8_;
		MetaWorkspace* _tmp12_;
#line 219 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		next = NULL;
#line 221 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp5_ = meta_workspace_get_neighbor (workspace, META_MOTION_LEFT);
#line 221 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 221 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_g_object_unref0 (next);
#line 221 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		next = _tmp6_;
#line 223 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp8_ = next;
#line 223 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		if (_tmp8_ == workspace) {
#line 223 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			_tmp7_ = TRUE;
#line 1111 "WorkspaceManager.c"
		} else {
			MetaWorkspace* _tmp9_;
#line 223 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			_tmp9_ = next;
#line 223 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			_tmp7_ = _tmp9_ == NULL;
#line 1118 "WorkspaceManager.c"
		}
#line 223 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		if (_tmp7_) {
#line 1122 "WorkspaceManager.c"
			MetaWorkspace* _tmp10_;
			MetaWorkspace* _tmp11_;
#line 224 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			_tmp10_ = meta_workspace_get_neighbor (workspace, META_MOTION_RIGHT);
#line 224 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			_tmp11_ = _g_object_ref0 (_tmp10_);
#line 224 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			_g_object_unref0 (next);
#line 224 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			next = _tmp11_;
#line 1133 "WorkspaceManager.c"
		}
#line 226 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp12_ = next;
#line 226 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		if (_tmp12_ != NULL) {
#line 1139 "WorkspaceManager.c"
			MetaWorkspace* _tmp13_;
			guint32 _tmp14_;
#line 227 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			_tmp13_ = next;
#line 227 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			_tmp14_ = time;
#line 227 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			meta_workspace_activate (_tmp13_, _tmp14_);
#line 1148 "WorkspaceManager.c"
		}
#line 218 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_g_object_unref0 (next);
#line 1152 "WorkspaceManager.c"
	}
#line 231 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp15_ = self->priv->workspaces_marked_removed;
#line 231 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp15_, workspace)) {
#line 232 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		return;
#line 1160 "WorkspaceManager.c"
	}
#line 235 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_parse_name ("window-added", meta_workspace_get_type (), &_tmp16_, NULL, FALSE);
#line 235 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (workspace, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp16_, 0, NULL, (GCallback) _gala_workspace_manager_window_added_meta_workspace_window_added, self);
#line 236 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_parse_name ("window-removed", meta_workspace_get_type (), &_tmp17_, NULL, FALSE);
#line 236 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (workspace, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _gala_workspace_manager_window_removed_meta_workspace_window_removed, self);
#line 238 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp18_ = self->priv->workspaces_marked_removed;
#line 238 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, workspace);
#line 240 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp19_ = screen;
#line 240 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp20_ = time;
#line 240 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	meta_screen_remove_workspace (_tmp19_, workspace, _tmp20_);
#line 1180 "WorkspaceManager.c"
}


/**
 * Temporarily disables removing workspaces when they are empty
 */
void
gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self)
{
	gint _tmp0_;
#line 246 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 248 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp0_ = self->priv->remove_freeze_count;
#line 248 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	self->priv->remove_freeze_count = _tmp0_ + 1;
#line 1197 "WorkspaceManager.c"
}


/**
 * Undo the effect of freeze_remove()
 */
void
gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self)
{
	gint _tmp0_;
	gint _tmp1_;
#line 254 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 256 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp0_ = self->priv->remove_freeze_count;
#line 256 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	self->priv->remove_freeze_count = _tmp0_ - 1;
#line 258 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp1_ = self->priv->remove_freeze_count;
#line 258 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_vala_assert (_tmp1_ >= 0, "remove_freeze_count >= 0");
#line 1219 "WorkspaceManager.c"
}


/**
 * If workspaces are dynamic, checks if there are empty workspaces that should
 * be removed. Particularily useful in conjunction with freeze/thaw_remove to
 * cleanup after an operation that required stable workspace/window indices
 */
void
gala_workspace_manager_cleanup (GalaWorkspaceManager* self)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	gint last_index = 0;
	MetaScreen* _tmp3_;
	MetaScreen* _tmp4_;
	GList* _tmp5_;
#line 266 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 268 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (!meta_prefs_get_dynamic_workspaces ()) {
#line 269 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		return;
#line 1245 "WorkspaceManager.c"
	}
#line 271 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 271 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 271 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 271 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	screen = _tmp2_;
#line 272 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp3_ = screen;
#line 272 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	last_index = meta_screen_get_n_workspaces (_tmp3_) - 1;
#line 274 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp4_ = screen;
#line 274 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp5_ = meta_screen_get_workspaces (_tmp4_);
#line 1263 "WorkspaceManager.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 274 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		workspace_collection = _tmp5_;
#line 274 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1271 "WorkspaceManager.c"
			MetaWorkspace* _tmp6_;
			MetaWorkspace* workspace = NULL;
#line 274 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			_tmp6_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 274 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			workspace = _tmp6_;
#line 1278 "WorkspaceManager.c"
			{
				gboolean _tmp7_ = FALSE;
				MetaWorkspace* _tmp8_;
#line 275 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				_tmp8_ = workspace;
#line 275 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				if (gala_utils_get_n_windows (_tmp8_) < ((guint) 1)) {
#line 1286 "WorkspaceManager.c"
					MetaWorkspace* _tmp9_;
					gint _tmp10_;
#line 276 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					_tmp9_ = workspace;
#line 276 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					_tmp10_ = last_index;
#line 276 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					_tmp7_ = meta_workspace_index (_tmp9_) != _tmp10_;
#line 1295 "WorkspaceManager.c"
				} else {
#line 275 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					_tmp7_ = FALSE;
#line 1299 "WorkspaceManager.c"
				}
#line 275 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				if (_tmp7_) {
#line 1303 "WorkspaceManager.c"
					MetaWorkspace* _tmp11_;
#line 277 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					_tmp11_ = workspace;
#line 277 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					gala_workspace_manager_remove_workspace (self, _tmp11_);
#line 1309 "WorkspaceManager.c"
				}
#line 274 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				_g_object_unref0 (workspace);
#line 1313 "WorkspaceManager.c"
			}
		}
	}
#line 266 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_g_object_unref0 (screen);
#line 1319 "WorkspaceManager.c"
}


GalaWindowManager*
gala_workspace_manager_get_wm (GalaWorkspaceManager* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	result = _tmp0_;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	return result;
#line 1336 "WorkspaceManager.c"
}


static void
gala_workspace_manager_set_wm (GalaWorkspaceManager* self,
                               GalaWindowManager* value)
{
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (gala_workspace_manager_get_wm (self) != value) {
#line 1348 "WorkspaceManager.c"
		GalaWindowManager* _tmp0_;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_g_object_unref0 (self->priv->_wm);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		self->priv->_wm = _tmp0_;
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM_PROPERTY]);
#line 1358 "WorkspaceManager.c"
	}
}


static GObject *
gala_workspace_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWorkspaceManager * self;
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	GeeLinkedList* _tmp2_;
	MetaScreen* _tmp10_;
	MetaScreen* _tmp11_;
	MetaScreen* _tmp12_;
	MetaScreen* _tmp13_;
	MetaScreen* _tmp14_;
	gboolean _tmp15_ = FALSE;
#line 49 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	parent_class = G_OBJECT_CLASS (gala_workspace_manager_parent_class);
#line 49 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 49 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 51 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 51 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 51 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	screen = _tmp1_;
#line 53 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp2_ = gee_linked_list_new (meta_workspace_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 53 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_g_object_unref0 (self->priv->workspaces_marked_removed);
#line 53 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	self->priv->workspaces_marked_removed = _tmp2_;
#line 55 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (meta_prefs_get_dynamic_workspaces ()) {
#line 1401 "WorkspaceManager.c"
		MetaScreen* _tmp3_;
#line 56 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp3_ = screen;
#line 56 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		meta_screen_override_workspace_layout (_tmp3_, META_SCREEN_TOPLEFT, FALSE, 1, -1);
#line 1407 "WorkspaceManager.c"
	}
	{
		gint i = 0;
#line 58 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		i = 0;
#line 1413 "WorkspaceManager.c"
		{
			gboolean _tmp4_ = FALSE;
#line 58 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			_tmp4_ = TRUE;
#line 58 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
			while (TRUE) {
#line 1420 "WorkspaceManager.c"
				gint _tmp6_;
				MetaScreen* _tmp7_;
				MetaScreen* _tmp8_;
				gint _tmp9_;
#line 58 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				if (!_tmp4_) {
#line 1427 "WorkspaceManager.c"
					gint _tmp5_;
#line 58 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					_tmp5_ = i;
#line 58 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					i = _tmp5_ + 1;
#line 1433 "WorkspaceManager.c"
				}
#line 58 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				_tmp4_ = FALSE;
#line 58 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				_tmp6_ = i;
#line 58 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				_tmp7_ = screen;
#line 58 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				if (!(_tmp6_ < meta_screen_get_n_workspaces (_tmp7_))) {
#line 58 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
					break;
#line 1445 "WorkspaceManager.c"
				}
#line 59 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				_tmp8_ = screen;
#line 59 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				_tmp9_ = i;
#line 59 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
				gala_workspace_manager_workspace_added (self, _tmp8_, _tmp9_);
#line 1453 "WorkspaceManager.c"
			}
		}
	}
#line 61 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	meta_prefs_add_listener (_gala_workspace_manager_prefs_listener_meta_prefs_changed_func, self);
#line 63 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp10_ = screen;
#line 63 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp10_, "workspace-switched", (GCallback) _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched, self, G_CONNECT_AFTER);
#line 64 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp11_ = screen;
#line 64 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp11_, "workspace-added", (GCallback) _gala_workspace_manager_workspace_added_meta_screen_workspace_added, self, 0);
#line 65 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp12_ = screen;
#line 65 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp12_, "workspace-removed", (GCallback) _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed, self, G_CONNECT_AFTER);
#line 66 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp13_ = screen;
#line 66 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp13_, "window-entered-monitor", (GCallback) _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor, self, 0);
#line 67 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp14_ = screen;
#line 67 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp14_, "window-left-monitor", (GCallback) _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor, self, 0);
#line 70 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (meta_prefs_get_dynamic_workspaces ()) {
#line 1481 "WorkspaceManager.c"
		MetaScreen* _tmp16_;
		MetaScreen* _tmp17_;
		MetaWorkspace* _tmp18_;
#line 71 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp16_ = screen;
#line 71 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp17_ = screen;
#line 71 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp18_ = meta_screen_get_workspace_by_index (_tmp16_, meta_screen_get_n_workspaces (_tmp17_) - 1);
#line 71 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp15_ = gala_utils_get_n_windows (_tmp18_) > ((guint) 0);
#line 1493 "WorkspaceManager.c"
	} else {
#line 70 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		_tmp15_ = FALSE;
#line 1497 "WorkspaceManager.c"
	}
#line 70 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	if (_tmp15_) {
#line 72 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		gala_workspace_manager_append_workspace (self);
#line 1503 "WorkspaceManager.c"
	}
#line 49 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	return obj;
#line 1507 "WorkspaceManager.c"
}


static void
gala_workspace_manager_class_init (GalaWorkspaceManagerClass * klass)
{
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	gala_workspace_manager_parent_class = g_type_class_peek_parent (klass);
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_type_class_add_private (klass, sizeof (GalaWorkspaceManagerPrivate));
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_workspace_manager_get_property;
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_workspace_manager_set_property;
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_workspace_manager_constructor;
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_workspace_manager_finalize;
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WORKSPACE_MANAGER_WM_PROPERTY, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1528 "WorkspaceManager.c"
}


static void
gala_workspace_manager_instance_init (GalaWorkspaceManager * self)
{
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	self->priv = GALA_WORKSPACE_MANAGER_GET_PRIVATE (self);
#line 42 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	self->priv->remove_freeze_count = 0;
#line 1539 "WorkspaceManager.c"
}


static void
gala_workspace_manager_finalize (GObject * obj)
{
	GalaWorkspaceManager * self;
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	guint _tmp3_;
	MetaScreen* _tmp4_;
	guint _tmp5_;
	MetaScreen* _tmp6_;
	guint _tmp7_;
	MetaScreen* _tmp8_;
	guint _tmp9_;
	MetaScreen* _tmp10_;
	guint _tmp11_;
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 77 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 77 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 77 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	screen = _tmp1_;
#line 79 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	meta_prefs_remove_listener (_gala_workspace_manager_prefs_listener_meta_prefs_changed_func, self);
#line 81 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp2_ = screen;
#line 81 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_parse_name ("workspace-added", meta_screen_get_type (), &_tmp3_, NULL, FALSE);
#line 81 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_added_meta_screen_workspace_added, self);
#line 82 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp4_ = screen;
#line 82 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_parse_name ("workspace-switched", meta_screen_get_type (), &_tmp5_, NULL, FALSE);
#line 82 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched, self);
#line 83 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp6_ = screen;
#line 83 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_parse_name ("workspace-removed", meta_screen_get_type (), &_tmp7_, NULL, FALSE);
#line 83 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed, self);
#line 84 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp8_ = screen;
#line 84 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_parse_name ("window-entered-monitor", meta_screen_get_type (), &_tmp9_, NULL, FALSE);
#line 84 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor, self);
#line 85 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_tmp10_ = screen;
#line 85 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_parse_name ("window-left-monitor", meta_screen_get_type (), &_tmp11_, NULL, FALSE);
#line 85 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor, self);
#line 39 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_g_object_unref0 (self->priv->_wm);
#line 41 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	_g_object_unref0 (self->priv->workspaces_marked_removed);
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	G_OBJECT_CLASS (gala_workspace_manager_parent_class)->finalize (obj);
#line 1606 "WorkspaceManager.c"
}


GType
gala_workspace_manager_get_type (void)
{
	static volatile gsize gala_workspace_manager_type_id__volatile = 0;
	if (g_once_init_enter (&gala_workspace_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaWorkspaceManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_workspace_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWorkspaceManager), 0, (GInstanceInitFunc) gala_workspace_manager_instance_init, NULL };
		GType gala_workspace_manager_type_id;
		gala_workspace_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaWorkspaceManager", &g_define_type_info, 0);
		g_once_init_leave (&gala_workspace_manager_type_id__volatile, gala_workspace_manager_type_id);
	}
	return gala_workspace_manager_type_id__volatile;
}


static void
_vala_gala_workspace_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		case GALA_WORKSPACE_MANAGER_WM_PROPERTY:
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		g_value_set_object (value, gala_workspace_manager_get_wm (self));
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		break;
#line 1640 "WorkspaceManager.c"
		default:
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		break;
#line 1646 "WorkspaceManager.c"
	}
}


static void
_vala_gala_workspace_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		case GALA_WORKSPACE_MANAGER_WM_PROPERTY:
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		gala_workspace_manager_set_wm (self, g_value_get_object (value));
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		break;
#line 1667 "WorkspaceManager.c"
		default:
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/deepin-wm-1.9.30/src/WorkspaceManager.vala"
		break;
#line 1673 "WorkspaceManager.c"
	}
}



